#ifndef lint
/*static char yysccsid[] = "from: @(#)yaccpar	1.9 (Berkeley) 02/21/93";*/
static char yyrcsid[] = "$Id: skeleton.c,v 1.4 1993/12/21 18:45:32 jtc Exp $";
#endif
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define yyclearin (yychar=(-1))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING (yyerrflag!=0)
#define YYPREFIX "yy"
#line 1 "dylan.y"
 /* Emacs: -*- Fundamental -*- */

/*
   This software is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.

   This software is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with this software; if not, write to the Free
   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

   Original authorship and copyright notices follows

 */

/* interim-dylan.y -- dylan phrase grammar from 5/12/94 interim report */

/*
 * this grammar is, i believe, an accurate translation of the
 * BNF grammar in the appendix to the 5/12/94 interim report
 * into yacc-friendly format.  the differences are
 *
 *	+ where the BNF used ellipses to indicate repitition,
 *	  (right) recursive productions have been added.
 *
 *	+ the grammar has been rearranged to eliminate ambiguities
 *	  (what yacc calls conflicts);  this grammar should have
 *	  no shift/reduce or reduce/reduce conflicts.  occasional
 *	  comments explain what had to be done in the dicier of
 *	  situations.
 *
 *	+ according to notes from the partners' mailing list, a
 *	  few productions were omitted from the grammar in the
 *	  report;  these are flagged with the comment "omitted"
 *	  in this grammar.
 *
 * paul haahr
 * 22 may 1994
 */

/*
   Marlais Revisions Copyright 1994, Joseph N. Wilson.  All Rights Reserved.

   Permission to use, copy, and modify this software and its
   documentation is hereby granted only under the following terms and
   conditions.  Both the above copyright notice and this permission
   notice must appear in all copies of the software, derivative works
   or modified version, and both notices must appear in supporting
   documentation.  Users of this software agree to the terms and
   conditions set forth in this notice.
*/

/* 
 * Modified this to have built-in rules for control constructs.
 * I'll save macro implementation for a little later.
 * 
 * jnw@cis.ufl.edu
 * 15 July 1994
 */

#ifdef MACOS
#define YYDEBUG 0
#endif

/* #define OPTIMIZE_SPECIALIZERS */

#include "boolean.h"
#include "bytestring.h"
#include "error.h"
#include "gc.h"
#include "globaldefs.h"
#include "list.h"
#include "number.h"
#include "object.h"
#include "symbol.h"
#include "table.h"
#include "vector.h"
#include "yystype.h"

#define alloca GC_malloc

void yyerror (char *);
static Object append_bang (Object l1, Object l2);
static Object nelistem (Object car,...);

extern char *yytext;
extern Object *parse_value_ptr;

extern int yylineno;

void push_intermediate_words (Object begin_word);
void pop_intermediate_words (void);

Object binding_stack;
Object symtab;
Object methnames, methdefs;
static void push_bindings();
static void pop_bindings();
static Object bindings_top ();
static void bindings_increment ();
static Object gensym(int i);
static Object make_setter_expr (Object place, Object value);
static int allocation_word (Object word);
#line 123 "y.tab.c"
#define SYMBOL 257
#define KEYWORD 258
#define LITERAL 259
#define STRING 260
#define COLON_EQUAL 261
#define GREATER_EQUAL 262
#define LESSER_EQUAL 263
#define NOT_EQUAL 264
#define NOT_EQUAL_EQUAL 265
#define EQUAL_EQUAL 266
#define EQUAL_ARROW 267
#define COLON_COLON 268
#define QUESTION_QUESTION 269
#define ELLIPSIS 270
#define UNRECOGNIZED 271
#define EOF_TOKEN 272
#define HASH_T 273
#define HASH_F 274
#define HASH_BRACKET 275
#define HASH_PAREN 276
#define HASH_NEXT 277
#define HASH_REST 278
#define HASH_KEY 279
#define HASH_ALL_KEYS 280
#define DEFINE 281
#define END 282
#define GENERIC 283
#define HANDLER 284
#define LET 285
#define LOCAL 286
#define METHOD 287
#define FUNCTION 288
#define OTHERWISE 289
#define CLASS 290
#define CONSTANT 291
#define LIBRARY 292
#define MODULE 293
#define VARIABLE 294
#define TEST 295
#define SLOT 296
#define BEGIN_TOKEN 297
#define CASE 298
#define IF 299
#define UNLESS 300
#define UNTIL 301
#define WHILE 302
#define BLOCK 303
#define FOR 304
#define SELECT 305
#define USE 306
#define EXPORT 307
#define CREATE 308
#define ELSE 309
#define ELSEIF 310
#define BY 311
#define FINALLY 312
#define THEN 313
#define IN 314
#define FROM 315
#define TO 316
#define ABOVE 317
#define BELOW 318
#define AFTERWARDS 319
#define CLEANUP 320
#define EXCEPTION 321
#define YYERRCODE 256
short yylhs[] = {                                        -1,
    1,    1,    1,    1,    1,    1,    0,    0,    0,    0,
    0,    0,    0,    5,    5,    8,    6,    7,    7,   10,
   10,   10,    9,    9,    9,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,   11,   11,   12,   12,   14,   14,   13,   13,
   13,   13,   18,   18,   18,   18,   19,   19,   19,   19,
   17,   17,   20,   20,   20,   20,   21,   21,   21,   21,
   21,   21,   25,   25,   28,   28,   29,   29,   31,   31,
   31,   30,   30,   24,   24,   24,   24,   24,   24,   24,
   24,   24,   41,   32,   42,   45,   33,   43,   43,   44,
   44,   44,   44,   34,   35,   48,   52,   48,   51,   51,
   54,   51,   51,   51,   55,   51,   50,   50,   57,   59,
   36,   58,   58,   60,   64,   60,   63,   63,   65,   63,
   63,   63,   66,   63,   62,   62,   62,   37,   38,   70,
   73,   76,   39,   77,   77,   71,   71,   78,   78,   78,
   81,   81,   81,   81,   82,   82,   72,   72,   72,   72,
   74,   74,   83,   87,   40,   84,   84,   85,   85,   86,
   86,   89,   89,   46,   46,   47,   47,   49,   49,   61,
   61,   68,   68,   69,   69,   75,   75,   88,   88,    2,
    2,    2,    2,    2,   97,    2,   99,    2,    2,   96,
  103,  103,  103,  105,  105,  107,  107,  107,  106,  106,
   92,   93,   94,   98,  110,  110,  112,  112,  112,  113,
  114,  115,  118,  118,  102,   67,   67,  117,  117,  121,
   22,   22,   22,  109,  109,  109,  123,  123,  123,  123,
  125,  125,  125,  126,  126,  126,  127,  127,  127,  127,
  124,  124,  128,  128,  128,  130,  130,  132,    4,    4,
  136,    4,  133,  133,  134,  135,  138,  135,   95,   95,
  139,  139,  139,  140,  140,  140,   80,   16,   16,  101,
  101,  141,  137,  142,  142,  143,  144,  144,  146,  146,
  147,  147,  148,   56,   56,   23,   23,  108,  108,  104,
  104,  100,  100,  111,  111,   53,   53,   79,   79,   90,
   90,   15,   15,   27,   27,   26,   26,  131,  131,  119,
  119,   91,   91,  120,  120,  116,  116,  145,  145,  129,
  129,  122,  122,
};
short yylen[] = {                                         2,
    1,    1,    1,    1,    1,    1,    1,    2,    2,    1,
    1,    2,    2,    0,    1,    0,    2,    1,    3,    0,
    1,    3,    1,    1,    1,    1,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    1,    1,    1,    2,    1,    1,    4,    4,
    3,    1,    4,    4,    3,    1,    2,    1,    4,    3,
    3,    1,    1,    1,    4,    1,    1,    1,    1,    1,
    3,    3,    1,    2,    1,    2,    1,    3,    1,    3,
    3,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    0,    4,    0,    0,   10,    0,    1,    0,
    1,    2,    6,    7,    4,    0,    0,    4,    0,    1,
    0,    4,    1,    3,    0,    5,    2,    2,    0,    0,
   10,    0,    2,    0,    0,    4,    0,    1,    0,    4,
    1,    3,    0,    5,    2,    6,    2,    7,    7,    0,
    0,    0,   12,    2,    3,    0,    1,    5,    3,    5,
    0,    2,    2,    2,    0,    2,    0,    2,    2,    2,
    0,    2,    0,    0,   12,    0,    2,    0,    2,    0,
    6,    1,    4,    0,    1,    0,    1,    0,    1,    0,
    1,    0,    1,    0,    1,    0,    1,    0,    1,    4,
    4,    4,    3,    3,    0,    5,    0,    4,   10,    6,
    0,    1,    3,    1,    4,    0,    2,    2,    3,    4,
    5,    5,    2,    5,    0,    3,    1,    1,    1,    3,
    2,    2,    1,    2,    3,    1,    3,    1,    3,    0,
    6,    7,    9,    3,    5,    7,    1,    3,    3,    1,
    2,    4,    1,    2,    4,    1,    1,    3,    2,    1,
    2,    3,    1,    1,    3,    4,    3,    2,    2,    5,
    0,    3,    1,    4,    1,    2,    0,    5,    3,    5,
    1,    3,    2,    1,    3,    2,    2,    1,    1,    0,
    1,    2,    1,    1,    2,    3,    1,    3,    1,    3,
    1,    3,    1,    0,    1,    0,    1,    0,    1,    0,
    1,    0,    1,    0,    1,    0,    1,    0,    1,    0,
    2,    0,    1,    0,    1,    0,    1,    0,    1,    0,
    1,    0,    1,    0,    1,    0,    1,    0,    1,    0,
    1,    0,    1,
};
short yydefred[] = {                                      0,
    0,  278,   43,   67,    0,    0,   47,    7,   48,   11,
   69,   70,    0,    0,    0,    0,  261,    0,    1,    2,
    3,    4,    5,    6,   93,    0,   95,    0,    0,    0,
  163,  140,  119,    0,  279,    0,    0,   10,   26,   44,
    0,    0,   64,   52,   62,   63,   66,   68,   84,   85,
   86,   87,   88,   89,   90,   91,   92,   12,   13,    0,
   74,    0,   83,   82,    0,  315,    0,    0,    0,  317,
    0,    0,  197,    0,    0,    0,  323,    0,    0,    0,
    0,  259,    0,    0,    0,    0,    0,    0,    0,  107,
    0,    0,    0,    0,    0,    0,    0,    8,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    9,    0,    0,    0,    0,   76,
   61,   72,    0,   71,    0,    0,  224,  194,    0,  193,
    0,    0,    0,    0,  195,    0,    0,    0,    0,    0,
   56,    0,    0,  277,  331,    0,  297,    0,  262,    0,
    0,    0,  250,    0,    0,    0,  237,  240,  243,  246,
    0,    0,   15,    0,  295,  118,  117,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   42,    0,    0,    0,  313,    0,   51,   78,   80,
   81,    0,  198,    0,    0,  192,    0,  190,    0,  191,
    0,  273,    0,    0,    0,    0,    0,    0,    0,    0,
  282,    0,    0,    0,    0,    0,    0,  254,    0,  249,
    0,    0,  251,    0,    0,   65,   94,   23,    0,   24,
   17,    0,  179,  105,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  147,    0,    0,    0,    0,    0,   49,
   50,    0,    0,    0,    0,    0,  217,  218,  219,    0,
    0,  213,    0,    0,    0,  196,  272,    0,    0,    0,
  327,    0,    0,    0,   55,    0,  260,  267,    0,    0,
    0,  248,    0,    0,    0,    0,    0,  238,  239,    0,
  111,    0,  307,  108,    0,    0,    0,    0,    0,    0,
    0,    0,  141,    0,  144,    0,    0,    0,    0,  120,
    0,   60,    0,    0,  221,  222,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  264,  285,   53,   54,
    0,  242,  245,    0,    0,  257,  319,  255,    0,    0,
    0,    0,   19,    0,    0,  115,  114,   99,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  145,    0,    0,
    0,    0,    0,   59,  220,    0,  305,    0,  216,    0,
    0,    0,  299,    0,    0,  321,    0,    0,    0,    0,
    0,  204,    0,    0,    0,  286,  268,  256,    0,    0,
    0,    0,  333,    0,  231,    0,  112,    0,    0,    0,
   96,  177,  104,  185,  139,  183,  138,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  229,  281,  214,    0,
    0,  211,  212,    0,  225,    0,    0,  207,    0,  208,
    0,    0,    0,  293,    0,  329,    0,    0,  276,    0,
    0,  232,   22,  116,  102,    0,    0,  167,    0,  170,
    0,    0,    0,    0,    0,    0,  150,    0,    0,    0,
  125,    0,  303,    0,    0,  235,  227,    0,    0,  209,
  301,    0,  203,    0,  288,    0,    0,  275,    0,    0,
    0,  169,    0,    0,    0,    0,    0,  137,    0,    0,
  135,  199,    0,  210,  311,  200,  205,  290,  292,  233,
    0,  175,   97,    0,    0,  162,  142,    0,  181,  121,
    0,    0,    0,  236,    0,    0,    0,    0,    0,  129,
    0,  126,  103,    0,    0,  189,  165,  187,  143,    0,
    0,    0,  133,  132,    0,    0,  136,  130,    0,    0,
  171,  134,  173,
};
short yydgoto[] = {                                      34,
   35,  238,  239,  240,  162,  163,  241,  164,  246,  353,
   39,   40,   41,   42,  195,   43,   44,  140,  196,   45,
   46,   85,  148,   47,   48,   68,   65,   61,   66,   67,
   70,   49,   50,   51,   52,   53,   54,   55,   56,   57,
   86,   91,  359,  411,  457,  513,  413,   89,  244,   90,
  247,  169,  304,  354,  408,  166,   97,  320,  373,  470,
  520,  471,  523,  500,  541,  549,  472,  417,  415,   96,
  253,  313,  367,  495,  539,  528,  254,  255,  315,   81,
  425,  467,   95,  419,  460,  493,  515,  537,  535,  480,
   76,  208,  210,  206,   82,  276,  211,  203,  129,  474,
  429,  334,  390,  482,  391,  392,  438,  384,  272,  265,
  378,  266,  267,  268,  269,  280,  325,   77,  387,  155,
  297,  402,  156,  157,  158,  159,  160,  230,  144,  231,
  346,  347,  142,  287,  149,   83,  216,  341,  138,  403,
  145,  281,  282,  396,  445,  446,  447,  448,
};
short yysindex[] = {                                   2982,
  -50,    0,    0,    0, -252, 3919,    0,    0,    0,    0,
    0,    0,  502,  502,  351,  553,    0,   89,    0,    0,
    0,    0,    0,    0,    0, 3719,    0,   97,  103,  150,
    0,    0,    0,    0,    0,   -6, 4372,    0,    0,    0,
   35, 4038,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, -252,
    0, 2209,    0,    0,  117,    0,  176,  172,    5,    0,
  -18,  322,    0,  322,  -17,  214,    0,  253, 4091,  -25,
  189,    0,   11,  726,  -20,    0,   40, 4210,  -12,    0,
  240, 3919, 3919, 3919,  259,  287,  317,    0, 3919, 3919,
 3919, 3919, 3919, 3919, 3919, 3919, 3919, 3919, 3919, 3919,
 3919, 3919, 3919, 3919,    0, 3987, 3987,  717,   35,    0,
    0,    0,  502,    0,  502,  502,    0,    0,  717,    0,
  319,  717,  717,  717,    0,  717,  316,  323, 4038,  139,
    0,  304, 4038,    0,    0, 3919,    0,  717,    0,  717,
  717,  622,    0, -190,  332,  330,    0,    0,    0,    0,
   11,   94,    0, 3632,    0,    0,    0,   83, 3308, 3919,
 4399, 4407, 4442,  717,  717, 3919, 4650,  620,  620,  169,
  169,  169,  169,  169,  169,  169,  169,   41,   41,  285,
  285,    0, 3919, 4467,  348,    0,  294,    0,    0,    0,
    0,   91,    0, 3987,  352,    0,   89,    0,   89,    0,
  717,    0,  253,  343,   35,  365, 3987, 3987,  717, 3919,
    0, 4650,  367,  369,  376,  717,  141,    0,  -25,    0,
  382, 3919,    0,  187,  726,    0,    0,    0, 4650,    0,
    0,  373,    0,    0, 3719,  375,  391, 4477,    0,    0,
    0,  419, -134,    0,  417,  -56, 2921, 4502, 3987,    0,
    0,  717,  717,  717,  181,  405,    0,    0,    0,  424,
  726,    0,  184,  196,  441,    0,    0, 3919,  224,  442,
    0,  365,  443,  400,    0, 4650,    0,    0,  167,  -79,
  -25,    0,  434,  841, 4650,  346,  391,    0,    0, 3632,
    0, 3071,    0,    0,    0,  229,  232,  238,    0, 3919,
 3919, 3919,    0,  717,    0, 3919, 3919, 3919, 3919,    0,
 3987,    0,  365,  452,    0,    0,  233,   91,    0,  486,
   11,  242, 3919, -124, 4650, 3817,    0,    0,    0,    0,
   11,    0,    0,  434, 3919,    0,    0,    0,  860,  469,
    0,  480,    0, 3308, 4210,    0,    0,    0,  -74,  241,
  248,  249,  223, 4650, 4650, 4650,  509,    0,    3, 4650,
 2743, 4650,  517,    0,    0,  717,    0,  717,    0,  274,
  292,  717,    0,  717, 4550,    0,  519,   31,  -73,  279,
  506,    0,  270,  717, 4650,    0,    0,    0, 4650,  717,
  525,  536,    0,    0,    0, 3632,    0, 3308,    0,  548,
    0,    0,    0,    0,    0,    0,    0,    0,  269,    0,
 3919, 3919, 3919, 3919,  281, 3870,    0,    0,    0,  295,
  416,    0,    0, 3919,    0,   73,  550,    0,  -73,    0,
  307, -124,  717,    0,  479,    0,  588,  368,    0,  860,
  391,    0,    0,    0,    0, 3919,  366,    0,    0,    0,
  345, 4650, 4650, 4650, 4650, 3919,    0, 3919,   40,  377,
    0,  393,    0,  717,  860,    0,    0,  550, 3987,    0,
    0,  717,    0,  550,    0,  717,  717,    0,    0, 4561,
  359,    0,  340,    0,  392, 4650, 4315,    0,  378, 3388,
    0,    0,  637,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  644,  403,    0,    0, 3919,    0,    0,
 3870,  627,  391,    0,  -74,  717,  384,  385,  649,    0,
 3122,    0,    0,  431,  657,    0,    0,    0,    0,  437,
 3388, 4550,    0,    0,  717,    0,    0,    0, 3388,  550,
    0,    0,    0,
};
short yyrindex[] = {                                      0,
    0,    0,    0,    0,  309,    0,    0,    0,    0,    0,
    0,    0,  608,  664,  225,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  445,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1300,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  430,
    0,    0,    0,    0,    0,    0,  630,    0,  683,    0,
  389,    0,    0,    0,    0,    0,    0,    0,    0,  -28,
    0,    0,  765,  684,    0, 3452, 3186,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  687,  636,    0, 1367,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  689,    0,    0,  677,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  714,    0,  111,    0,  729,    0,    0,    0,    0,
  540,    0,    0,    0,    0,    0,    0,  609,  485,    0,
    0,    0,    0,    0,  135,    0, 2390, 2294, 2365, 1761,
 1827, 1905, 1971, 2058, 2135, 2202, 2268, 1597, 1674, 1464,
 1530,    0, 4142,  -38,    0,    0,    0,    0,    0,    0,
    0,  490,    0,  687,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  444,  732,  687,    0,    0,    0,
    0,   98,  119,  733,  740,    0,    0,    0,  334,    0,
  742,    0,    0, 3251,    0,    0,    0,    0,  286,    0,
    0, -117,    0,    0,  -34,  504,  510,    0, 3452, 3452,
 3452,    0,  747,    0,  147,    0,  752,  -37,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  684,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   32,    0,    0,    0,  132,    0,    0,    0,    0,
  334,    0,  155,    0,  165,    0, 3517,    0,    0,  475,
    0,  485,    0,    0, 2847,    0,    0,    0, 2553,    0,
    0,    0,    0,  157,    0,    0,    0,    0,    0,    0,
    0,    0,  741,  749,    0,    0, 3347,  490, 3452,    0,
 2432, 2704,  778, -197,  197,    0,    0,    0,    0,    0,
  765,    0,    0,  155,    0,    0,    0,    0,  779,    0,
 3452,  515,    0,  485,  -33,    0,    0,    0,  539,  675,
 1137, 1234, -113,  782,  785,  787,    0,    0,    0,  -29,
   -7,  788,    0,    0,    0,    0,    0,  470,    0,    0,
  584,   23,    0,  470,  -35,    0,    0,  542,  542,    0,
  557,    0,    0,  715,   18,    0,    0,    0,  183,    0,
  822,    0,    0, 3452,    0,  475,    0,  485, 3574,    0,
    0,    0,    0,    0,    0,    0,    0, 2604, -132, 2791,
    0,    0,    0,    0,  -24,  586,    0,    0,    0,  243,
    0,    0,    0,    0,    0,  542,  -30,    0,  542,    0,
 3663, -197,    0,    0,    0,    0,  744,   14,    0,    0,
 3517,    0,    0,    0,    0,    0,    0,    0, 2653,    0,
  -20,   -5,   -1,   13,   27,    0,    0,    0, 3186,    0,
    0,    0,    0,  470,  779,    0,    0,  -30,    0,    0,
    0,  470,    0,  -30,    0,    0,    0,    0, 3452,    0,
  771,    0,  595, 3452,    0,   81,    0,    0,  906,  596,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 2920,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  -21,  599,  510,    0,  539,    0, 1002, 1068,    0,    0,
  596,    0,    0,  846,    0,    0,    0,    0,    0,    0,
  596,  -41,    0,    0,    0, 2653,    0,    0,  596,  847,
    0,    0,    0,
};
short yygindex[] = {                                      0,
    0,  889,    1,  890, 2313, -281,    0,    0, -164,  491,
    0,    0,   10,    0,  -43,   12,    0,    0, -139,  813,
   47,  -26, -151,    0,    0,    0,    0,  838,  776,   33,
  774,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  383,    0,    0,    0,    0,    0, -210,
 -233,    0, -295,    0,    0,  432,    0,    0,    0,    0,
    0, -451, -183,    0,    0,    0, -303,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  593,    0,    0,  -59,
    0,    0,    0,    0,    0,    0,    0,    0,    0, -412,
    0,  761,    0,    0,  251,    0,    0,    0,    0,    0,
 -340,    0,  489,    0,    0,    0, -302,    0,    0,  604,
    0,    0,    0,    0,    0,  611, -253,  864,    0,  672,
    0,  481,    0,  710,  719,  666,  668,  665, -140,    0,
  616,    0,    0,    0,  621,    0,  818,    0,  750,  514,
    0,  688,    0,    0,    0,  483,    0,  484,
};
#define YYTABLESIZE 4916
short yytable[] = {                                     242,
   37,  351,   58,   57,  316,  226,   62,   60,   58,  236,
  326,  149,  330,  233,  149,  330,  155,   25,  137,  155,
   58,   57,  280,  358,  110,   25,   88,   80,  310,  386,
  330,  393,  330,  151,  301,  148,  151,  128,  148,  152,
  100,  432,  152,  433,  113,  111,   69,  110,  126,  112,
  125,  119,   98,  153,   58,   57,  153,  291,  287,   64,
   64,  287,  105,  109,  104,  504,  280,  154,  357,  530,
  154,  507,  284,  197,  116,  232,  287,  143,  284,  543,
  118,  280,  113,   80,  201,   80,  440,  112,  293,   80,
  284,  356,  171,  172,  173,  154,  114,  269,  206,  177,
  178,  179,  180,  181,  182,  183,  184,  185,  186,  187,
  188,  189,  190,  191,  192,  256,  194,  194,  266,  322,
  407,  156,  427,  310,  156,  117,  101,  455,   84,  198,
  477,  265,  388,  502,  114,  352,   92,  553,  291,  393,
  202,  506,   93,  205,  207,  209,  222,  212,  215,  168,
  344,  330,  215,  137,  330,  489,  269,  200,   69,  207,
  270,  224,  225,  229,   18,  389,  311,  312,  166,   64,
  248,   64,   64,  283,  454,  146,  257,  266,  217,  382,
  273,  374,  274,  439,  219,  252,   80,  308,  168,   94,
  265,   18,   18,  258,   18,  318,  270,  309,  318,  152,
  153,   18,   18,   18,  194,  252,  166,  166,  252,  122,
  113,  111,  124,  110,  529,  112,  389,  194,  194,  123,
  286,   59,  275,  258,   80,  226,  258,  532,  149,  218,
  285,  226,  295,  155,  409,  410,  350,  291,   71,  131,
   25,  352,  143,   58,   57,   88,  154,  110,   25,  146,
  151,  310,  148,  330,  256,  270,  152,  317,  318,  194,
  128,  161,  114,   99,  102,  103,  106,  107,  108,  168,
  153,  149,  149,  323,  324,  324,  155,  155,  335,  170,
  330,  330,  154,  330,  154,  330,  330,  436,  437,  401,
  330,  330,  330,  151,  151,  148,  148,  147,  174,  152,
  152,  302,  355,  151,  280,  229,  165,   80,   73,  152,
  364,  365,  366,  153,  153,  421,  369,  370,  371,  372,
  389,  194,  128,  153,  130,   80,  175,  154,  154,  439,
  478,  280,  280,  385,  280,  522,  395,  154,  156,  505,
  449,  280,  280,  280,   25,  399,   73,  544,   73,   73,
   73,   73,   73,   73,   73,   73,  176,  548,  204,  213,
   80,   78,  389,  214,  220,  552,  522,   73,   73,   73,
   73,  476,  234,  235,  330,  237,  522,  330,  114,  269,
  243,  156,  156,  484,  522,  349,  261,  324,  260,  428,
  401,  271,  146,  428,  330,  428,  262,  263,  264,   73,
  266,   73,   73,  278,  308,  444,  269,  269,  279,  269,
  288,   80,  289,  265,  309,  401,  269,  269,  269,  290,
  292,  462,  463,  464,  465,  294,  385,  266,  266,   75,
  266,  300,   73,  302,  385,  146,  146,  266,  266,  266,
  265,  265,   80,  265,  151,  152,  153,  308,  308,  303,
  265,  265,  265,  296,   80,  475,  490,  309,  309,  309,
  314,   80,  327,  328,  329,  331,  496,   75,  497,   75,
   75,   75,   75,   75,   75,   75,   75,  332,  270,  194,
  333,  336,  337,  339,  283,  428,   80,  283,   75,   75,
   75,   75,  340,  428,  345,  376,  132,  444,  444,  302,
  133,  134,  283,  135,  283,  270,  270,  322,  270,    2,
  360,  322,  322,  361,  322,  270,  270,  270,  385,  362,
   75,  385,   75,   75,  302,  377,  381,  404,  280,  383,
  136,  542,  302,  302,  302,  302,  302,  534,  406,  296,
  412,  418,   19,   20,   21,   22,   23,   24,  414,  420,
  416,  302,  302,   75,  302,  430,  550,  426,  431,  435,
  441,  302,  302,  302,  442,  443,   73,   25,  450,   73,
   73,   73,   73,   73,   73,   73,  451,  296,    2,  296,
  296,  296,  296,  296,  296,  296,  296,  456,  459,  473,
   73,  466,   78,  479,   25,   25,  481,   25,  296,  296,
  296,  296,    2,  485,   25,   25,   25,   71,  178,   73,
   73,   19,   20,   21,   22,   23,   24,   73,   73,   73,
   73,   73,   73,   73,   73,   73,   73,   73,   73,   73,
  296,  486,  296,  296,  487,   19,   20,   21,   22,   23,
   24,   72,  234,   73,   74,   75,  178,  491,  178,  178,
  178,  178,  178,  178,  178,  178,  494,  512,  499,  501,
  514,  113,  111,  296,  110,  227,  112,  178,  178,  178,
  178,  223,    2,  517,  176,  223,  223,  524,  223,  105,
  109,  104,  519,  526,  527,  531,  536,   75,  538,  540,
   75,   75,   75,   75,   75,   75,   75,  546,  545,  178,
  314,  178,  178,  547,  316,   19,   20,   21,   22,   23,
   24,   75,  176,  114,  176,  176,  176,  176,  176,  176,
  176,  176,   77,   79,  324,  283,  106,  312,  312,  271,
   75,   75,  178,  176,  176,  176,  176,  263,   75,   75,
   75,   75,   75,   75,   75,   75,   75,   75,   75,   75,
   75,  280,  283,  283,  247,  283,   20,  283,  283,   63,
    4,    5,  283,  283,  283,  176,  109,  176,  176,  325,
  174,  215,  326,  241,   11,   12,   13,   14,  280,  280,
  244,  280,  253,   20,   20,  113,   20,  157,  280,  280,
  280,  306,  122,   20,   20,   20,   21,  296,  176,  326,
  296,  296,  296,  296,  296,  296,  296,  228,  174,    2,
  174,  174,  174,  174,  174,  174,  174,  174,  320,  332,
  100,  296,  160,   21,   21,  158,   21,  159,  123,  174,
  174,  174,  174,   21,   21,   21,   79,  206,  202,  328,
  296,  296,   19,   20,   21,   22,   23,   24,  296,  296,
  296,  296,  296,  296,  296,  296,  296,  296,  296,  296,
  296,  174,  274,  174,  174,  234,  178,  124,  289,  178,
  178,  178,  178,  178,  178,  178,  164,  127,    2,  226,
  131,  102,  103,  106,  107,  108,  172,  310,   36,   38,
  178,  141,  234,  234,  174,  234,  453,  120,  199,  201,
  498,  228,  234,  234,  234,  180,  368,  533,  223,  178,
  178,   19,   20,   21,   22,   23,   24,  178,  178,  178,
  178,  178,  178,  178,  178,  178,  178,  178,  178,  178,
  483,  379,  176,  375,  127,  176,  176,  176,  176,  176,
  176,  176,  330,  180,  298,  180,  180,  180,  180,  180,
  180,  180,  180,  299,  342,  503,  176,  343,  348,  398,
  221,  397,  277,  488,  180,  180,  180,  180,  508,  338,
  509,    0,    0,    2,    0,  176,  176,    0,    0,    0,
    0,    0,    2,  176,  176,  176,  176,  176,  176,  176,
  176,  176,  176,  176,  176,  176,  180,    0,  180,  180,
    0,  188,  150,  151,  152,  153,   19,   20,   21,   22,
   23,   24,    0,    0,    0,   19,   20,   21,   22,   23,
   24,  296,    0,    0,    0,    0,    0,    0,  174,  180,
    0,  174,  174,  174,  174,  174,  174,  174,    0,  188,
    0,  188,  188,  188,  188,  188,  188,  188,  188,    0,
    0,    0,  174,    0,  296,  296,  296,  296,  296,  296,
  188,  188,  188,  188,    0,    0,    0,  186,    0,    0,
    0,  174,  174,    0,    0,    0,    0,    0,    0,  174,
  174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
  174,  174,  188,    0,  188,  188,    0,    2,  226,    0,
    0,    0,    0,    0,    0,  186,    0,  186,  186,  186,
  186,  186,  186,  186,  186,    0,    2,    0,    0,    0,
  228,    0,    0,    0,    0,  188,  186,  186,  186,  186,
   19,   20,   21,   22,   23,   24,  184,  400,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   19,
   20,   21,   22,   23,   24,    0,    0,    0,  186,    0,
  186,  186,    0,  180,    0,    0,  180,  180,  180,  180,
  180,  180,  180,    0,  184,    0,  184,  184,  184,  184,
  184,  184,  184,  184,    0,    0,    0,  180,    0,    0,
    0,  186,    0,    0,    0,  184,  184,  184,  184,    0,
    0,    0,    0,    0,    0,    0,  180,  180,    0,    0,
    0,    0,    0,    0,  180,  180,  180,  180,  180,  180,
  180,  180,  180,  180,  180,  180,  180,  184,    0,  184,
  184,    0,    0,  182,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  188,
  184,    0,  188,  188,  188,  188,  188,  188,  188,    0,
    0,  182,    0,  182,  182,  182,  182,  182,  182,  182,
  182,    0,    0,  188,    0,    0,    0,    0,    0,    0,
    0,    0,  182,  182,  182,  182,    0,    0,    0,   45,
    0,    0,  188,  188,    0,    0,    0,    0,    0,    0,
  188,  188,  188,  188,  188,  188,  188,  188,  188,  188,
  188,  188,  188,    0,  182,  186,  182,  182,  186,  186,
  186,  186,  186,  186,  186,    0,    0,   45,    0,    0,
   45,   45,   45,   45,   45,    0,   45,    0,    0,  186,
    0,    0,    0,    0,    0,    0,    0,  182,   45,   45,
   45,   45,    0,    0,    0,    0,   46,    0,  186,  186,
    0,    0,    0,    0,    0,    0,  186,  186,  186,  186,
  186,  186,  186,  186,  186,  186,  186,  186,  186,    0,
    0,    0,   45,   45,  184,    0,    0,  184,  184,  184,
  184,  184,  184,  184,   46,    0,    0,   46,   46,   46,
   46,   46,    0,   46,    0,    0,    0,    0,  184,    0,
    0,    0,    0,   45,    0,   46,   46,   46,   46,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  184,    0,
    0,    0,    0,    0,    0,  184,  184,  184,  184,  184,
  184,  184,  184,  184,  184,  184,  184,  184,    0,   46,
   46,    0,    0,   40,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   46,  182,    0,    0,  182,  182,  182,  182,  182,  182,
  182,   40,    0,    0,   40,   40,   40,   40,   40,    0,
   40,    0,    0,    0,    0,  182,    0,    0,    0,    0,
    0,    0,   40,   40,   40,   40,    0,    0,    0,   41,
    0,    0,    0,    0,  182,    0,    0,    0,    0,    0,
    0,    0,  182,  182,  182,  182,  182,  182,  182,  182,
  182,  182,  182,  182,  182,    0,   40,   45,    0,    0,
   45,   45,   45,   45,   45,   45,   45,   41,    0,    0,
   41,   41,   41,   41,   41,    0,   41,    0,    0,    0,
    0,   45,    0,    0,    0,    0,    0,   40,   41,   41,
   41,   41,    0,    0,    0,    0,   38,    0,    0,    0,
   45,   45,    0,    0,    0,    0,    0,    0,   45,   45,
   45,   45,   45,    0,    0,   45,   45,   45,   45,   45,
   45,    0,   41,    0,   46,    0,    0,   46,   46,   46,
   46,   46,   46,   46,   38,    0,    0,   38,    0,   38,
   38,   38,    0,    0,    0,    0,    0,    0,   46,    0,
    0,    0,    0,   41,    0,   38,   38,   38,   38,    0,
    0,    0,    0,    0,    0,    0,    0,   46,   46,    0,
    0,    0,    0,   39,    0,   46,   46,   46,   46,   46,
    0,    0,   46,   46,   46,   46,   46,   46,    0,   38,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   39,    0,    0,   39,    0,   39,   39,   39,    0,
   38,   40,    0,    0,   40,   40,   40,   40,   40,   40,
   40,    0,   39,   39,   39,   39,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   40,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   30,    0,    0,    0,   40,   40,   39,    0,    0,    0,
    0,    0,   40,   40,   40,   40,   40,    0,    0,   40,
   40,   40,   40,   40,   40,    0,    0,   41,    0,    0,
   41,   41,   41,   41,   41,   41,   41,   39,   30,    0,
    0,   30,    0,    0,   30,    0,    0,    0,    0,    0,
    0,   41,    0,    0,    0,    0,    0,    0,    0,   30,
   30,   30,   30,    0,    0,    0,   31,    0,    0,    0,
   41,   41,    0,    0,    0,    0,    0,    0,   41,   41,
   41,   41,   41,    0,    0,   41,   41,   41,   41,   41,
   41,    0,    0,   30,   38,    0,    0,   38,   38,   38,
   38,   38,   38,   38,   31,    0,    0,   31,    0,    0,
   31,    0,    0,    0,    0,    0,    0,    0,   38,    0,
    0,    0,    0,    0,   30,   31,   31,   31,   31,    0,
    0,    0,    0,    0,    0,    0,    0,   38,   38,    0,
    0,    0,    0,    0,   33,   38,   38,   38,   38,   38,
    0,    0,   38,   38,   38,   38,   38,   38,    0,   31,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   39,    0,    0,   39,   39,   39,   39,   39,   39,
   39,    0,   33,    0,    0,   33,    0,    0,   33,    0,
   31,    0,    0,    0,    0,   39,    0,    0,    0,    0,
    0,    0,    0,   33,   33,   33,   33,    0,    0,    0,
   32,    0,    0,    0,   39,   39,    0,    0,    0,    0,
    0,    0,   39,   39,   39,   39,   39,    0,    0,   39,
   39,   39,   39,   39,   39,    0,    0,   33,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   32,    0,
    0,   32,    0,    0,   32,    0,    0,    0,   30,    0,
    0,   30,   30,   30,   30,   30,   30,   30,   33,   32,
   32,   32,   32,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   30,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   34,    0,    0,
    0,   30,   30,   32,    0,    0,    0,    0,    0,   30,
   30,   30,   30,   30,    0,    0,   30,   30,   30,   30,
   30,   30,    0,    0,   31,    0,    0,   31,   31,   31,
   31,   31,   31,   31,   32,   34,    0,    0,   34,    0,
    0,   34,    0,    0,    0,    0,    0,    0,   31,    0,
    0,    0,    0,    0,    0,    0,   34,   34,   34,   34,
    0,    0,    0,    0,    0,    0,    0,   31,   31,    0,
    0,    0,    0,    0,   35,   31,   31,   31,   31,   31,
    0,    0,   31,   31,   31,   31,   31,   31,    0,    0,
   34,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   33,    0,    0,   33,   33,   33,   33,   33,
   33,   33,   35,    0,    0,   35,    0,    0,   35,    0,
    0,   34,    0,    0,    0,    0,   33,    0,    0,    0,
    0,    0,    0,   35,   35,   35,   35,    0,    0,    0,
    0,   36,    0,    0,    0,   33,   33,    0,    0,    0,
    0,    0,    0,   33,   33,   33,   33,   33,    0,    0,
   33,   33,   33,   33,   33,   33,    0,   35,   32,    0,
    0,   32,   32,   32,   32,   32,   32,   32,    0,   36,
    0,    0,   36,    0,    0,   36,  100,    0,    0,  121,
  113,  111,   32,  110,    0,  112,    0,    0,   35,    0,
   36,   36,   36,   36,    0,    0,    0,   37,  105,  109,
  104,   32,   32,    0,    0,    0,    0,    0,    0,   32,
   32,   32,   32,   32,    0,    0,   32,   32,   32,   32,
   32,   32,    0,   28,   36,    0,    0,    0,    0,    0,
    0,    0,  114,    0,    0,   37,    0,    0,   37,    0,
    0,   37,    0,    0,    0,   34,    0,    0,   34,   34,
   34,   34,   34,   34,   34,   36,   37,   37,   37,   37,
    0,   28,  101,    0,   28,    0,    0,   28,    0,   34,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   28,    0,    0,    0,    0,    0,   34,   34,
   37,    0,    0,    0,   29,    0,   34,   34,   34,   34,
   34,    0,    0,   34,   34,   34,   34,   34,   34,    0,
    0,    0,    0,    0,    0,    0,   28,    0,    0,   27,
    0,   37,   35,    0,    0,   35,   35,   35,   35,   35,
   35,   35,   29,    0,    0,   29,    0,    0,   29,    0,
    0,    0,    0,    0,    0,    0,   35,   28,    0,    0,
    0,    0,    0,   29,    0,    0,    0,    0,    0,    0,
   27,  296,    0,   27,    0,   35,   35,    0,    0,    0,
    0,    0,    0,   35,   35,   35,   35,   35,   27,    0,
   35,   35,   35,   35,   35,   35,    0,   29,    0,   36,
    0,    0,   36,   36,   36,   36,   36,   36,   36,   99,
  102,  103,  106,  107,  108,  296,    0,    0,    0,    0,
    0,    0,   27,   36,    0,    0,    0,    0,   29,    0,
  296,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   36,   36,    0,    0,    0,    0,    0,    0,
   36,   36,   36,   36,   36,    0,    0,   36,   36,   36,
   36,   36,   36,    0,    0,   37,    0,    0,   37,   37,
   37,   37,   37,   37,   37,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   37,
    0,   28,    0,    0,   28,    0,    0,    0,    0,    0,
   28,  306,  307,  308,    0,    0,    0,    0,   37,   37,
    0,    0,    0,    0,    0,   28,   37,   37,   37,   37,
   37,    0,    0,   37,   37,   37,   37,   37,   37,    0,
    0,    0,   16,    0,   28,   28,    0,   16,    0,    0,
    0,    0,   28,   28,   28,   28,   28,    0,    0,   28,
   28,   28,   28,   28,   28,    0,    0,    0,    0,    0,
    0,  363,   29,    0,    0,   29,    0,    0,    0,    0,
    0,   29,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  380,    0,   16,    0,    0,   29,   27,   16,    0,
    0,    0,    0,    0,    0,    0,   27,    0,    0,    0,
    0,    0,    0,  405,    0,   29,   29,    0,    0,    0,
    0,   27,    0,   29,   29,   29,   29,   29,   16,    0,
   29,   29,   29,   29,   29,   29,    0,    0,  296,    0,
   27,   27,   16,    0,    0,    0,    0,   16,   27,   27,
   27,   27,   27,    0,    0,   27,   27,   27,   27,   27,
   27,    0,    0,  296,    0,    0,  452,    0,    0,    0,
    0,  296,  296,  296,  296,  296,  296,    0,    0,   16,
  458,    0,  461,    0,    0,    0,    0,    0,    0,    0,
  296,  296,    0,  296,    0,    0,    0,    0,    0,    0,
  296,  296,  296,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  298,    0,    0,    0,    0,    0,    0,    0,
    0,  492,    0,    0,    0,    0,    0,    0,   16,    0,
  100,    0,    0,    0,  113,  111,    0,  110,    0,  112,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  510,  105,  109,  104,    0,  516,    0,    0,   16,
   16,   16,   16,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  525,    0,   16,   16,   16,   16,    0,
   16,    0,    0,   16,   14,   16,  114,   16,   16,   16,
    0,    0,   16,   16,   16,   16,   16,   16,    0,   16,
   16,   16,   16,   16,   16,   16,   16,   16,  551,    0,
   16,   16,   16,   16,    0,    0,  101,    0,    0,    0,
    0,   14,   14,   14,    0,    0,   16,   16,   16,   16,
    0,    0,    0,    0,   16,   14,   16,    0,   16,   16,
   16,   16,    0,   16,   16,   16,   16,   16,   16,    0,
   16,   16,   16,   16,   16,   16,   16,   16,   16,   16,
   16,   16,   16,    0,    0,    0,   16,    0,    0,    0,
    0,    0,    0,   14,   14,   16,   16,   16,   16,    0,
    0,    0,    0,   16,   14,    0,    0,   16,   16,   16,
    0,    0,   16,   16,   16,   16,   16,   16,    0,   16,
   16,   16,   16,   16,   16,   16,   16,   16,  100,   16,
  298,    0,  113,  111,   16,  110,    0,  112,    0,    0,
    0,    0,   16,   14,    0,    0,    0,    0,    0,    0,
  105,  109,  104,    0,    0,  298,    0,    0,    0,    0,
    0,    0,    0,  298,  298,  298,  298,  298,  298,    0,
    0,    0,    0,   99,  102,  103,  106,  107,  108,    0,
    0,    0,  298,  298,  114,  298,    0,    0,    0,    0,
    0,    6,  298,  298,  298,    0,    7,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    8,    0,    0,    0,  101,   16,    0,   16,   16,   16,
   16,    0,    0,    0,    0,    0,    0,    0,  422,  423,
  424,    0,    0,   16,   16,   16,   16,    0,    0,    0,
    0,   16,   14,    0,    0,   16,   16,   16,    0,    0,
   16,   16,   16,   16,   16,   16,    0,   16,   16,   16,
   16,   16,   16,   16,   16,   16,    0,    0,    0,    0,
    0,    0,   14,   16,   16,   16,   16,    9,    0,    0,
    6,    0,    0,    0,    0,    7,    0,    0,    0,   16,
   16,   16,   16,    0,    0,    0,    0,   16,   98,  245,
    0,   16,   16,   16,    0,    0,   16,   16,   16,   16,
   16,   16,    0,   16,   16,   16,   16,   16,   16,   16,
   16,   16,    0,    0,    0,   98,   98,    0,    0,    0,
    0,  468,    0,    0,    0,    0,    7,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   16,   16,   16,   16,
  521,   99,  102,  103,  106,  107,  108,    0,    0,    0,
    0,    0,   16,   16,   16,   16,    9,    0,    0,    0,
   16,   14,    0,    0,   16,   16,   16,    0,    0,   16,
   16,   16,   16,   16,   16,    0,   16,   16,   16,   16,
   16,   16,   16,   16,   16,  294,    0,    0,   14,   14,
  294,  319,    0,    0,    0,    0,    0,    1,    2,    3,
    4,    5,    0,    0,  294,    0,    0,    9,    0,    0,
    0,    0,    0,   10,   11,   12,   13,   14,    0,    0,
    0,    0,   15,    0,    0,    0,   16,   17,   18,    0,
    0,   19,   20,   21,   22,   23,   24,    0,   25,   26,
   27,   28,   29,   30,   31,   32,   33,    0,    0,    0,
  230,    0,    0,    0,    0,  230,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  230,
    0,  294,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    2,    3,    4,
    5,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   11,   12,   13,   14,    6,    0,    0,
    0,   15,    7,    0,    0,   16,   17,   18,    0,   87,
   19,   20,   21,   22,   23,   24,  245,   25,   26,   27,
   28,   29,   30,   31,   32,   33,  230,    0,    2,    3,
    4,    5,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   11,   12,   13,   14,    0,    0,
    0,    0,   15,    0,    0,  304,   16,   17,   18,    0,
  469,   19,   20,   21,   22,   23,   24,    0,   25,   26,
   27,   28,   29,   30,   31,   32,   33,    6,    0,    0,
    0,    0,    7,    9,    0,    0,    0,    0,    0,    0,
    0,    0,  294,  294,  294,  294,  521,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  294,  294,
  294,  294,    0,    0,    0,    0,  294,  294,    0,    0,
  294,  294,  294,    0,    0,  294,  294,  294,  294,  294,
  294,    0,  294,  294,  294,  294,  294,  294,  294,  294,
  294,   16,    0,    0,    0,    0,   16,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  230,  230,  230,
  230,    0,    0,    9,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  230,  230,  230,  230,    0,    0,    0,
    0,  230,  230,    0,    0,  230,  230,  230,    0,    0,
  230,  230,  230,  230,  230,  230,    0,  230,  230,  230,
  230,  230,  230,  230,  230,  230,  306,    0,    0,    0,
    0,  306,    0,    0,    2,    3,    4,    5,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   16,    0,    0,
   11,   12,   13,   14,    0,    0,    0,    0,   15,    0,
    0,    0,   16,   17,   18,    0,    0,   19,   20,   21,
   22,   23,   24,  304,   25,   26,   27,   28,   29,   30,
   31,   32,   33,   16,    0,    0,    0,    0,   16,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  304,    0,
    0,    0,    0,    0,    0,    0,  304,  304,  304,    0,
  304,  304,  306,    0,    2,    3,    4,    5,    0,    0,
    0,    0,    0,    0,    0,  304,  304,    0,  304,    0,
   11,   12,   13,   14,    0,  304,  304,  304,   15,    0,
    0,    6,   16,   17,   18,    0,    7,   19,   20,   21,
   22,   23,   24,    0,   25,   26,   27,   28,   29,   30,
   31,   32,   33,    0,    0,    0,    0,    0,    0,   16,
    0,    0,    0,    0,    0,    0,    0,    0,   16,   16,
   16,   16,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  300,    0,    0,   16,   16,   16,   16,    0,    0,
    0,    0,   16,   14,    0,    0,   16,   16,   16,    0,
    0,   16,   16,   16,   16,   16,   16,    0,   16,   16,
   16,   16,   16,   16,   16,   16,   16,    9,    6,    0,
    0,    0,    0,    7,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  306,  306,  306,  306,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  306,
  306,  306,  306,    0,    0,    0,    0,  306,  306,    0,
    0,  306,  306,  306,    0,    0,  306,  306,  306,  306,
  306,  306,    0,  306,  306,  306,  306,  306,  306,  306,
  306,  306,    0,    0,    0,    0,    0,    0,    0,    0,
   16,   16,   16,   16,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    9,    0,   16,   16,   16,   16,
    0,    0,    0,    0,   16,  101,    6,    0,   16,   16,
   16,    7,    0,   16,   16,   16,   16,   16,   16,    0,
   16,   16,   16,   16,   16,   16,   16,   16,   16,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    2,    3,
    4,    5,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   11,   12,   13,   14,    0,  468,
    0,    0,   15,    0,    7,    0,   16,   17,   18,  300,
    0,   19,   20,   21,   22,   23,   24,    0,   25,   26,
   27,   28,   29,   30,   31,   32,   33,    0,    0,  394,
    0,    0,    9,    0,  300,    0,    0,    0,    0,    0,
    0,    0,    0,  300,  300,  300,  300,  300,    6,    0,
    0,    0,    0,    7,    0,    0,    0,    0,    0,    0,
    0,  300,  300,    0,  300,    2,    3,    4,    5,    0,
    0,  300,  300,  300,    0,    0,    0,    0,    0,    0,
    0,   11,   12,   13,   14,    9,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   18,    0,   87,   19,   20,
   21,   22,   23,   24,    0,   25,   26,   27,   28,   29,
   30,   31,   32,   33,    0,    0,    6,    0,    0,    0,
    0,    7,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    9,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    2,    3,    4,    5,    6,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   11,
   12,   13,   14,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   18,    0,    0,   19,   20,   21,   22,
   23,   24,    9,   25,   26,   27,   28,   29,   30,   31,
   32,   33,    0,    0,    0,    0,    2,    3,    4,    5,
  139,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   11,   12,   13,   14,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   18,    0,  469,   19,
   20,   21,   22,   23,   24,    0,   25,   26,   27,   28,
   29,   30,   31,   32,   33,    2,    3,    4,    5,   43,
    0,    0,   43,   43,   43,   43,    0,    0,   43,    0,
    0,   11,   12,   13,   14,    0,    0,    0,    0,    0,
   43,   43,   43,   43,    0,   18,    0,    0,   19,   20,
   21,   22,   23,   24,    0,   25,   26,   27,   28,   29,
   30,   31,   32,   33,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   43,   43,    0,    0,    0,    0,
    0,    0,    0,    2,  193,    4,    5,  100,    0,    0,
    0,  113,  111,    0,  110,    0,  112,    0,    0,   11,
   12,   13,   14,    0,    0,   43,    0,    0,    0,  105,
  109,  104,    0,   18,    0,    0,   19,   20,   21,   22,
   23,   24,    0,   25,   26,   27,   28,   29,   30,   31,
   32,   33,    0,    0,    2,    0,    4,    5,    0,    0,
    0,    0,    0,  114,    0,    0,    0,    0,    0,    0,
   11,   12,   13,   14,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   18,    0,    0,   19,   20,   21,
   22,   23,   24,  101,   25,   26,   27,   28,   29,   30,
   31,   32,   33,    0,    0,    0,    0,    2,    0,    4,
    5,    0,  100,    0,    0,  121,  113,  111,  518,  110,
    0,  112,    0,   11,   12,   13,   14,    0,    0,    0,
    0,    0,    0,    0,  105,  109,  104,   18,    0,    0,
   19,   20,   21,   22,   23,   24,    0,   25,   26,   27,
   28,   29,   30,   31,   32,   33,    0,    0,    0,    0,
    0,    0,   43,   43,   43,   43,   43,   43,  114,  100,
    0,    0,    0,  113,  111,    0,  110,    0,  112,    0,
    0,    0,    0,   43,    0,    0,    0,    0,    0,    0,
  115,  105,  109,  104,    0,    0,  100,    0,  101,  249,
  113,  111,    0,  110,  100,  112,    0,  250,  113,  111,
    0,  110,    0,  112,    0,    0,    0,    0,  105,  109,
  104,    0,    0,    0,    0,  114,  105,  109,  104,    0,
   99,  102,  103,  106,  107,  108,  167,    0,    0,  100,
    0,    0,  251,  113,  111,    0,  110,    0,  112,    0,
    0,    0,  114,    0,    0,  101,    0,    0,    0,    0,
  114,  105,  109,  104,  100,    0,    0,    0,  113,  111,
  259,  110,    0,  112,  100,    0,    0,  305,  113,  111,
    0,  110,  101,  112,    0,    0,  105,  109,  104,    0,
  101,    0,    0,    0,    0,  114,  105,  109,  104,  100,
    0,    0,    0,  113,  111,  321,  110,    0,  112,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  114,  105,  109,  104,    0,  101,    0,    0,    0,    0,
  114,    0,    0,    0,    0,   99,  102,  103,  106,  107,
  108,    0,    0,    0,    0,    0,    0,  100,    0,    0,
  101,  113,  111,  434,  110,  114,  112,    0,  100,    0,
  101,  511,  113,  111,    0,  110,    0,  112,    0,  105,
  109,  104,    0,    0,    0,    0,    0,    0,    0,    0,
  105,  109,  104,    0,    0,  101,    0,    0,    0,    0,
    0,    0,   99,  102,  103,  106,  107,  108,    0,    0,
    0,    0,    0,  114,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  114,    0,    0,    0,    0,   99,
  102,  103,  106,  107,  108,    0,    0,   99,  102,  103,
  106,  107,  108,  101,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  101,    0,    0,  100,    0,    0,
    0,  113,  111,    0,  110,    0,  112,    0,    0,    0,
    0,    0,   99,  102,  103,  106,  107,  108,    0,  105,
  109,  104,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   99,  102,  103,
  106,  107,  108,    0,    0,    0,    0,   99,  102,  103,
  106,  107,  108,  114,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   99,  102,  103,  106,  107,  108,    0,    0,
    0,    0,    0,  101,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   99,  102,  103,  106,  107,  108,    0,    0,    0,    0,
    0,   99,  102,  103,  106,  107,  108,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   99,  102,  103,  106,  107,  108,
};
short yycheck[] = {                                     164,
    0,  297,   41,   41,   61,   41,    6,  260,   59,  161,
  264,   41,   41,  154,   44,   44,   41,   59,   78,   44,
   59,   59,    0,  305,   59,   59,   26,   16,   59,  333,
   59,  334,   61,   41,  245,   41,   44,   59,   44,   41,
   38,  382,   44,  384,   42,   43,   14,   45,   44,   47,
   46,   42,   59,   41,   93,   93,   44,   44,   41,   13,
   14,   44,   60,   61,   62,  478,   44,   41,  302,  521,
   44,  484,   41,  117,   40,  266,   59,  268,  218,  531,
   46,   59,   42,   72,  282,   74,  389,   47,  229,   78,
   59,  302,   92,   93,   94,   84,   94,    0,  296,   99,
  100,  101,  102,  103,  104,  105,  106,  107,  108,  109,
  110,  111,  112,  113,  114,  175,  116,  117,    0,  259,
  354,   41,  376,  258,   44,   91,  124,  409,   40,  118,
  434,    0,  257,  474,   94,  300,   40,  550,  125,  442,
  129,  482,   40,  132,  133,  134,  146,  136,  139,  282,
  291,   41,  143,  213,   44,  451,   59,  125,  126,  148,
  204,  150,  151,  152,  282,  290,  301,  302,  282,  123,
  170,  125,  126,  217,  408,   41,  176,   59,   40,  331,
  207,  321,  209,  257,   46,  174,  175,   41,  321,   40,
   59,  309,  310,  193,  312,   41,    0,   41,   44,  279,
  280,  319,  320,  321,  204,   41,  320,  321,   44,   93,
   42,   43,   41,   45,  518,   47,  290,  217,  218,   44,
  220,  272,  211,   41,  213,  267,   44,  523,  258,   91,
  219,  267,  232,  258,  309,  310,  296,  226,  257,  257,
  282,  406,  268,  282,  282,  245,  235,  282,  282,   61,
  258,  282,  258,  282,  314,   59,  258,  314,  315,  259,
  282,  282,   94,  261,  262,  263,  264,  265,  266,  282,
  258,  301,  302,  262,  263,  264,  301,  302,  278,   40,
  309,  310,  271,  312,  258,  314,  315,  257,  258,  349,
  319,  320,  321,  301,  302,  301,  302,  287,   40,  301,
  302,   59,  302,  311,  282,  294,  267,  296,    0,  311,
  310,  311,  312,  301,  302,  313,  316,  317,  318,  319,
  290,  321,   72,  311,   74,  314,   40,  301,  302,  257,
  258,  309,  310,  333,  312,  500,  336,  311,  258,  479,
  400,  319,  320,  321,   59,  345,   38,  531,   40,   41,
   42,   43,   44,   45,   46,   47,   40,  541,   40,   44,
  349,   40,  290,   41,   61,  549,  531,   59,   60,   61,
   62,  431,   41,   44,   41,  282,  541,   44,   94,  282,
  298,  301,  302,  443,  549,   40,   93,  376,   41,  378,
  450,   40,  258,  382,   61,  384,  306,  307,  308,   91,
  282,   93,   94,   61,  258,  394,  309,  310,   44,  312,
   44,  400,   44,  282,  258,  475,  319,  320,  321,   44,
  280,  421,  422,  423,  424,   44,  426,  309,  310,    0,
  312,   59,  124,   59,  434,  301,  302,  319,  320,  321,
  309,  310,  431,  312,  278,  279,  280,  301,  302,   59,
  319,  320,  321,  267,  443,   40,  456,  301,  302,   41,
   44,  450,  282,   59,   41,  282,  466,   38,  468,   40,
   41,   42,   43,   44,   45,   46,   47,  282,  282,  479,
   40,  258,   41,   41,   41,  474,  475,   44,   59,   60,
   61,   62,   93,  482,   61,   44,  283,  486,  487,  257,
  287,  288,   59,  290,   61,  309,  310,  283,  312,  257,
  282,  287,  288,  282,  290,  319,  320,  321,  518,  282,
   91,  521,   93,   94,  282,  293,   41,   59,   59,  288,
  278,  531,  290,  291,  292,  293,  294,  526,   59,    0,
  300,  319,  290,  291,  292,  293,  294,  295,  301,   41,
  302,  309,  310,  124,  312,  282,  545,   41,  267,   41,
  282,  319,  320,  321,   59,  296,  258,  282,   44,  261,
  262,  263,  264,  265,  266,  267,   41,   38,  257,   40,
   41,   42,   43,   44,   45,   46,   47,   40,  320,  295,
  282,  311,   40,   44,  309,  310,  290,  312,   59,   60,
   61,   62,  257,  125,  319,  320,  321,  257,    0,  301,
  302,  290,  291,  292,  293,  294,  295,  309,  310,  311,
  312,  313,  314,  315,  316,  317,  318,  319,  320,  321,
   91,   44,   93,   94,  267,  290,  291,  292,  293,  294,
  295,  291,   59,  293,  294,  295,   38,  282,   40,   41,
   42,   43,   44,   45,   46,   47,  312,  299,  282,  267,
  321,   42,   43,  124,   45,   44,   47,   59,   60,   61,
   62,  283,  257,  282,    0,  287,  288,   41,  290,   60,
   61,   62,  305,   40,  282,   59,  303,  258,  304,   41,
  261,  262,  263,  264,  265,  266,  267,   41,  268,   91,
   93,   93,   94,  267,   41,  290,  291,  292,  293,  294,
  295,  282,   38,   94,   40,   41,   42,   43,   44,   45,
   46,   47,   93,   41,   41,  282,  282,   41,   93,   41,
  301,  302,  124,   59,   60,   61,   62,   61,  309,  310,
  311,  312,  313,  314,  315,  316,  317,  318,  319,  320,
  321,  282,  309,  310,   41,  312,  282,  314,  315,  258,
  259,  260,  319,  320,  321,   91,  282,   93,   94,   41,
    0,  282,   41,   41,  273,  274,  275,  276,  309,  310,
   41,  312,   41,  309,  310,  282,  312,   41,  319,  320,
  321,  282,   41,  319,  320,  321,  282,  258,  124,   59,
  261,  262,  263,  264,  265,  266,  267,   59,   38,  257,
   40,   41,   42,   43,   44,   45,   46,   47,   41,   41,
  282,  282,   41,  309,  310,   41,  312,   41,   41,   59,
   60,   61,   62,  319,  320,  321,  284,  296,  282,  125,
  301,  302,  290,  291,  292,  293,  294,  295,  309,  310,
  311,  312,  313,  314,  315,  316,  317,  318,  319,  320,
  321,   91,   41,   93,   94,  282,  258,  282,  125,  261,
  262,  263,  264,  265,  266,  267,  282,  282,  257,  258,
  282,  262,  263,  264,  265,  266,   41,   41,    0,    0,
  282,   79,  309,  310,  124,  312,  406,   60,  123,  126,
  469,  280,  319,  320,  321,    0,  314,  525,  148,  301,
  302,  290,  291,  292,  293,  294,  295,  309,  310,  311,
  312,  313,  314,  315,  316,  317,  318,  319,  320,  321,
  442,  328,  258,  323,   71,  261,  262,  263,  264,  265,
  266,  267,  271,   38,  235,   40,   41,   42,   43,   44,
   45,   46,   47,  235,  289,  475,  282,  290,  294,  344,
  143,  341,  213,  450,   59,   60,   61,   62,  486,  282,
  487,   -1,   -1,  257,   -1,  301,  302,   -1,   -1,   -1,
   -1,   -1,  257,  309,  310,  311,  312,  313,  314,  315,
  316,  317,  318,  319,  320,  321,   91,   -1,   93,   94,
   -1,    0,  277,  278,  279,  280,  290,  291,  292,  293,
  294,  295,   -1,   -1,   -1,  290,  291,  292,  293,  294,
  295,  257,   -1,   -1,   -1,   -1,   -1,   -1,  258,  124,
   -1,  261,  262,  263,  264,  265,  266,  267,   -1,   38,
   -1,   40,   41,   42,   43,   44,   45,   46,   47,   -1,
   -1,   -1,  282,   -1,  290,  291,  292,  293,  294,  295,
   59,   60,   61,   62,   -1,   -1,   -1,    0,   -1,   -1,
   -1,  301,  302,   -1,   -1,   -1,   -1,   -1,   -1,  309,
  310,  311,  312,  313,  314,  315,  316,  317,  318,  319,
  320,  321,   91,   -1,   93,   94,   -1,  257,  258,   -1,
   -1,   -1,   -1,   -1,   -1,   38,   -1,   40,   41,   42,
   43,   44,   45,   46,   47,   -1,  257,   -1,   -1,   -1,
  280,   -1,   -1,   -1,   -1,  124,   59,   60,   61,   62,
  290,  291,  292,  293,  294,  295,    0,  278,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  290,
  291,  292,  293,  294,  295,   -1,   -1,   -1,   91,   -1,
   93,   94,   -1,  258,   -1,   -1,  261,  262,  263,  264,
  265,  266,  267,   -1,   38,   -1,   40,   41,   42,   43,
   44,   45,   46,   47,   -1,   -1,   -1,  282,   -1,   -1,
   -1,  124,   -1,   -1,   -1,   59,   60,   61,   62,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  301,  302,   -1,   -1,
   -1,   -1,   -1,   -1,  309,  310,  311,  312,  313,  314,
  315,  316,  317,  318,  319,  320,  321,   91,   -1,   93,
   94,   -1,   -1,    0,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  258,
  124,   -1,  261,  262,  263,  264,  265,  266,  267,   -1,
   -1,   38,   -1,   40,   41,   42,   43,   44,   45,   46,
   47,   -1,   -1,  282,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   59,   60,   61,   62,   -1,   -1,   -1,    0,
   -1,   -1,  301,  302,   -1,   -1,   -1,   -1,   -1,   -1,
  309,  310,  311,  312,  313,  314,  315,  316,  317,  318,
  319,  320,  321,   -1,   91,  258,   93,   94,  261,  262,
  263,  264,  265,  266,  267,   -1,   -1,   38,   -1,   -1,
   41,   42,   43,   44,   45,   -1,   47,   -1,   -1,  282,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  124,   59,   60,
   61,   62,   -1,   -1,   -1,   -1,    0,   -1,  301,  302,
   -1,   -1,   -1,   -1,   -1,   -1,  309,  310,  311,  312,
  313,  314,  315,  316,  317,  318,  319,  320,  321,   -1,
   -1,   -1,   93,   94,  258,   -1,   -1,  261,  262,  263,
  264,  265,  266,  267,   38,   -1,   -1,   41,   42,   43,
   44,   45,   -1,   47,   -1,   -1,   -1,   -1,  282,   -1,
   -1,   -1,   -1,  124,   -1,   59,   60,   61,   62,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  302,   -1,
   -1,   -1,   -1,   -1,   -1,  309,  310,  311,  312,  313,
  314,  315,  316,  317,  318,  319,  320,  321,   -1,   93,
   94,   -1,   -1,    0,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  124,  258,   -1,   -1,  261,  262,  263,  264,  265,  266,
  267,   38,   -1,   -1,   41,   42,   43,   44,   45,   -1,
   47,   -1,   -1,   -1,   -1,  282,   -1,   -1,   -1,   -1,
   -1,   -1,   59,   60,   61,   62,   -1,   -1,   -1,    0,
   -1,   -1,   -1,   -1,  301,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  309,  310,  311,  312,  313,  314,  315,  316,
  317,  318,  319,  320,  321,   -1,   93,  258,   -1,   -1,
  261,  262,  263,  264,  265,  266,  267,   38,   -1,   -1,
   41,   42,   43,   44,   45,   -1,   47,   -1,   -1,   -1,
   -1,  282,   -1,   -1,   -1,   -1,   -1,  124,   59,   60,
   61,   62,   -1,   -1,   -1,   -1,    0,   -1,   -1,   -1,
  301,  302,   -1,   -1,   -1,   -1,   -1,   -1,  309,  310,
  311,  312,  313,   -1,   -1,  316,  317,  318,  319,  320,
  321,   -1,   93,   -1,  258,   -1,   -1,  261,  262,  263,
  264,  265,  266,  267,   38,   -1,   -1,   41,   -1,   43,
   44,   45,   -1,   -1,   -1,   -1,   -1,   -1,  282,   -1,
   -1,   -1,   -1,  124,   -1,   59,   60,   61,   62,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  301,  302,   -1,
   -1,   -1,   -1,    0,   -1,  309,  310,  311,  312,  313,
   -1,   -1,  316,  317,  318,  319,  320,  321,   -1,   93,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   38,   -1,   -1,   41,   -1,   43,   44,   45,   -1,
  124,  258,   -1,   -1,  261,  262,  263,  264,  265,  266,
  267,   -1,   59,   60,   61,   62,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  282,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
    0,   -1,   -1,   -1,  301,  302,   93,   -1,   -1,   -1,
   -1,   -1,  309,  310,  311,  312,  313,   -1,   -1,  316,
  317,  318,  319,  320,  321,   -1,   -1,  258,   -1,   -1,
  261,  262,  263,  264,  265,  266,  267,  124,   38,   -1,
   -1,   41,   -1,   -1,   44,   -1,   -1,   -1,   -1,   -1,
   -1,  282,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   59,
   60,   61,   62,   -1,   -1,   -1,    0,   -1,   -1,   -1,
  301,  302,   -1,   -1,   -1,   -1,   -1,   -1,  309,  310,
  311,  312,  313,   -1,   -1,  316,  317,  318,  319,  320,
  321,   -1,   -1,   93,  258,   -1,   -1,  261,  262,  263,
  264,  265,  266,  267,   38,   -1,   -1,   41,   -1,   -1,
   44,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  282,   -1,
   -1,   -1,   -1,   -1,  124,   59,   60,   61,   62,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  301,  302,   -1,
   -1,   -1,   -1,   -1,    0,  309,  310,  311,  312,  313,
   -1,   -1,  316,  317,  318,  319,  320,  321,   -1,   93,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  258,   -1,   -1,  261,  262,  263,  264,  265,  266,
  267,   -1,   38,   -1,   -1,   41,   -1,   -1,   44,   -1,
  124,   -1,   -1,   -1,   -1,  282,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   59,   60,   61,   62,   -1,   -1,   -1,
    0,   -1,   -1,   -1,  301,  302,   -1,   -1,   -1,   -1,
   -1,   -1,  309,  310,  311,  312,  313,   -1,   -1,  316,
  317,  318,  319,  320,  321,   -1,   -1,   93,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   38,   -1,
   -1,   41,   -1,   -1,   44,   -1,   -1,   -1,  258,   -1,
   -1,  261,  262,  263,  264,  265,  266,  267,  124,   59,
   60,   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  282,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,   -1,   -1,
   -1,  301,  302,   93,   -1,   -1,   -1,   -1,   -1,  309,
  310,  311,  312,  313,   -1,   -1,  316,  317,  318,  319,
  320,  321,   -1,   -1,  258,   -1,   -1,  261,  262,  263,
  264,  265,  266,  267,  124,   38,   -1,   -1,   41,   -1,
   -1,   44,   -1,   -1,   -1,   -1,   -1,   -1,  282,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   59,   60,   61,   62,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  301,  302,   -1,
   -1,   -1,   -1,   -1,    0,  309,  310,  311,  312,  313,
   -1,   -1,  316,  317,  318,  319,  320,  321,   -1,   -1,
   93,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  258,   -1,   -1,  261,  262,  263,  264,  265,
  266,  267,   38,   -1,   -1,   41,   -1,   -1,   44,   -1,
   -1,  124,   -1,   -1,   -1,   -1,  282,   -1,   -1,   -1,
   -1,   -1,   -1,   59,   60,   61,   62,   -1,   -1,   -1,
   -1,    0,   -1,   -1,   -1,  301,  302,   -1,   -1,   -1,
   -1,   -1,   -1,  309,  310,  311,  312,  313,   -1,   -1,
  316,  317,  318,  319,  320,  321,   -1,   93,  258,   -1,
   -1,  261,  262,  263,  264,  265,  266,  267,   -1,   38,
   -1,   -1,   41,   -1,   -1,   44,   38,   -1,   -1,   41,
   42,   43,  282,   45,   -1,   47,   -1,   -1,  124,   -1,
   59,   60,   61,   62,   -1,   -1,   -1,    0,   60,   61,
   62,  301,  302,   -1,   -1,   -1,   -1,   -1,   -1,  309,
  310,  311,  312,  313,   -1,   -1,  316,  317,  318,  319,
  320,  321,   -1,    0,   93,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   94,   -1,   -1,   38,   -1,   -1,   41,   -1,
   -1,   44,   -1,   -1,   -1,  258,   -1,   -1,  261,  262,
  263,  264,  265,  266,  267,  124,   59,   60,   61,   62,
   -1,   38,  124,   -1,   41,   -1,   -1,   44,   -1,  282,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   59,   -1,   -1,   -1,   -1,   -1,  301,  302,
   93,   -1,   -1,   -1,    0,   -1,  309,  310,  311,  312,
  313,   -1,   -1,  316,  317,  318,  319,  320,  321,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   93,   -1,   -1,    0,
   -1,  124,  258,   -1,   -1,  261,  262,  263,  264,  265,
  266,  267,   38,   -1,   -1,   41,   -1,   -1,   44,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  282,  124,   -1,   -1,
   -1,   -1,   -1,   59,   -1,   -1,   -1,   -1,   -1,   -1,
   41,    0,   -1,   44,   -1,  301,  302,   -1,   -1,   -1,
   -1,   -1,   -1,  309,  310,  311,  312,  313,   59,   -1,
  316,  317,  318,  319,  320,  321,   -1,   93,   -1,  258,
   -1,   -1,  261,  262,  263,  264,  265,  266,  267,  261,
  262,  263,  264,  265,  266,   44,   -1,   -1,   -1,   -1,
   -1,   -1,   93,  282,   -1,   -1,   -1,   -1,  124,   -1,
   59,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  301,  302,   -1,   -1,   -1,   -1,   -1,   -1,
  309,  310,  311,  312,  313,   -1,   -1,  316,  317,  318,
  319,  320,  321,   -1,   -1,  258,   -1,   -1,  261,  262,
  263,  264,  265,  266,  267,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  282,
   -1,  258,   -1,   -1,  261,   -1,   -1,   -1,   -1,   -1,
  267,  249,  250,  251,   -1,   -1,   -1,   -1,  301,  302,
   -1,   -1,   -1,   -1,   -1,  282,  309,  310,  311,  312,
  313,   -1,   -1,  316,  317,  318,  319,  320,  321,   -1,
   -1,   -1,   40,   -1,  301,  302,   -1,   45,   -1,   -1,
   -1,   -1,  309,  310,  311,  312,  313,   -1,   -1,  316,
  317,  318,  319,  320,  321,   -1,   -1,   -1,   -1,   -1,
   -1,  309,  258,   -1,   -1,  261,   -1,   -1,   -1,   -1,
   -1,  267,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  329,   -1,   40,   -1,   -1,  282,  258,   45,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  267,   -1,   -1,   -1,
   -1,   -1,   -1,  351,   -1,  301,  302,   -1,   -1,   -1,
   -1,  282,   -1,  309,  310,  311,  312,  313,  126,   -1,
  316,  317,  318,  319,  320,  321,   -1,   -1,  257,   -1,
  301,  302,   40,   -1,   -1,   -1,   -1,   45,  309,  310,
  311,  312,  313,   -1,   -1,  316,  317,  318,  319,  320,
  321,   -1,   -1,  282,   -1,   -1,  404,   -1,   -1,   -1,
   -1,  290,  291,  292,  293,  294,  295,   -1,   -1,  126,
  418,   -1,  420,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  309,  310,   -1,  312,   -1,   -1,   -1,   -1,   -1,   -1,
  319,  320,  321,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   59,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  459,   -1,   -1,   -1,   -1,   -1,   -1,  126,   -1,
   38,   -1,   -1,   -1,   42,   43,   -1,   45,   -1,   47,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  489,   60,   61,   62,   -1,  494,   -1,   -1,  257,
  258,  259,  260,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  511,   -1,  273,  274,  275,  276,   -1,
   40,   -1,   -1,  281,  282,   45,   94,  285,  286,  287,
   -1,   -1,  290,  291,  292,  293,  294,  295,   -1,  297,
  298,  299,  300,  301,  302,  303,  304,  305,  546,   -1,
  257,  258,  259,  260,   -1,   -1,  124,   -1,   -1,   -1,
   -1,  319,  320,  321,   -1,   -1,  273,  274,  275,  276,
   -1,   -1,   -1,   -1,  281,  282,   40,   -1,  285,  286,
  287,   45,   -1,  290,  291,  292,  293,  294,  295,   -1,
  297,  298,  299,  300,  301,  302,  303,  304,  305,  257,
  258,  259,  260,   -1,   -1,   -1,  126,   -1,   -1,   -1,
   -1,   -1,   -1,  320,  321,  273,  274,  275,  276,   -1,
   -1,   -1,   -1,  281,  282,   -1,   -1,  285,  286,  287,
   -1,   -1,  290,  291,  292,  293,  294,  295,   -1,  297,
  298,  299,  300,  301,  302,  303,  304,  305,   38,   40,
  257,   -1,   42,   43,   45,   45,   -1,   47,   -1,   -1,
   -1,   -1,  126,  321,   -1,   -1,   -1,   -1,   -1,   -1,
   60,   61,   62,   -1,   -1,  282,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  290,  291,  292,  293,  294,  295,   -1,
   -1,   -1,   -1,  261,  262,  263,  264,  265,  266,   -1,
   -1,   -1,  309,  310,   94,  312,   -1,   -1,   -1,   -1,
   -1,   40,  319,  320,  321,   -1,   45,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   59,   -1,   -1,   -1,  124,  126,   -1,  257,  258,  259,
  260,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  316,  317,
  318,   -1,   -1,  273,  274,  275,  276,   -1,   -1,   -1,
   -1,  281,  282,   -1,   -1,  285,  286,  287,   -1,   -1,
  290,  291,  292,  293,  294,  295,   -1,  297,  298,  299,
  300,  301,  302,  303,  304,  305,   -1,   -1,   -1,   -1,
   -1,   -1,  312,  257,  258,  259,  260,  126,   -1,   -1,
   40,   -1,   -1,   -1,   -1,   45,   -1,   -1,   -1,  273,
  274,  275,  276,   -1,   -1,   -1,   -1,  281,  282,   59,
   -1,  285,  286,  287,   -1,   -1,  290,  291,  292,  293,
  294,  295,   -1,  297,  298,  299,  300,  301,  302,  303,
  304,  305,   -1,   -1,   -1,  309,  310,   -1,   -1,   -1,
   -1,   40,   -1,   -1,   -1,   -1,   45,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  257,  258,  259,  260,
   59,  261,  262,  263,  264,  265,  266,   -1,   -1,   -1,
   -1,   -1,  273,  274,  275,  276,  126,   -1,   -1,   -1,
  281,  282,   -1,   -1,  285,  286,  287,   -1,   -1,  290,
  291,  292,  293,  294,  295,   -1,  297,  298,  299,  300,
  301,  302,  303,  304,  305,   40,   -1,   -1,  309,  310,
   45,  311,   -1,   -1,   -1,   -1,   -1,  256,  257,  258,
  259,  260,   -1,   -1,   59,   -1,   -1,  126,   -1,   -1,
   -1,   -1,   -1,  272,  273,  274,  275,  276,   -1,   -1,
   -1,   -1,  281,   -1,   -1,   -1,  285,  286,  287,   -1,
   -1,  290,  291,  292,  293,  294,  295,   -1,  297,  298,
  299,  300,  301,  302,  303,  304,  305,   -1,   -1,   -1,
   40,   -1,   -1,   -1,   -1,   45,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   59,
   -1,  126,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,  258,  259,
  260,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  273,  274,  275,  276,   40,   -1,   -1,
   -1,  281,   45,   -1,   -1,  285,  286,  287,   -1,  289,
  290,  291,  292,  293,  294,  295,   59,  297,  298,  299,
  300,  301,  302,  303,  304,  305,  126,   -1,  257,  258,
  259,  260,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  273,  274,  275,  276,   -1,   -1,
   -1,   -1,  281,   -1,   -1,   59,  285,  286,  287,   -1,
  289,  290,  291,  292,  293,  294,  295,   -1,  297,  298,
  299,  300,  301,  302,  303,  304,  305,   40,   -1,   -1,
   -1,   -1,   45,  126,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  257,  258,  259,  260,   59,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  273,  274,
  275,  276,   -1,   -1,   -1,   -1,  281,  282,   -1,   -1,
  285,  286,  287,   -1,   -1,  290,  291,  292,  293,  294,
  295,   -1,  297,  298,  299,  300,  301,  302,  303,  304,
  305,   40,   -1,   -1,   -1,   -1,   45,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,  258,  259,
  260,   -1,   -1,  126,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  273,  274,  275,  276,   -1,   -1,   -1,
   -1,  281,  282,   -1,   -1,  285,  286,  287,   -1,   -1,
  290,  291,  292,  293,  294,  295,   -1,  297,  298,  299,
  300,  301,  302,  303,  304,  305,   40,   -1,   -1,   -1,
   -1,   45,   -1,   -1,  257,  258,  259,  260,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  126,   -1,   -1,
  273,  274,  275,  276,   -1,   -1,   -1,   -1,  281,   -1,
   -1,   -1,  285,  286,  287,   -1,   -1,  290,  291,  292,
  293,  294,  295,  257,  297,  298,  299,  300,  301,  302,
  303,  304,  305,   40,   -1,   -1,   -1,   -1,   45,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  282,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  290,  291,  292,   -1,
  294,  295,  126,   -1,  257,  258,  259,  260,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  309,  310,   -1,  312,   -1,
  273,  274,  275,  276,   -1,  319,  320,  321,  281,   -1,
   -1,   40,  285,  286,  287,   -1,   45,  290,  291,  292,
  293,  294,  295,   -1,  297,  298,  299,  300,  301,  302,
  303,  304,  305,   -1,   -1,   -1,   -1,   -1,   -1,  126,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,  258,
  259,  260,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   59,   -1,   -1,  273,  274,  275,  276,   -1,   -1,
   -1,   -1,  281,  282,   -1,   -1,  285,  286,  287,   -1,
   -1,  290,  291,  292,  293,  294,  295,   -1,  297,  298,
  299,  300,  301,  302,  303,  304,  305,  126,   40,   -1,
   -1,   -1,   -1,   45,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  257,  258,  259,  260,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  273,
  274,  275,  276,   -1,   -1,   -1,   -1,  281,  282,   -1,
   -1,  285,  286,  287,   -1,   -1,  290,  291,  292,  293,
  294,  295,   -1,  297,  298,  299,  300,  301,  302,  303,
  304,  305,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  257,  258,  259,  260,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  126,   -1,  273,  274,  275,  276,
   -1,   -1,   -1,   -1,  281,  282,   40,   -1,  285,  286,
  287,   45,   -1,  290,  291,  292,  293,  294,  295,   -1,
  297,  298,  299,  300,  301,  302,  303,  304,  305,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,  258,
  259,  260,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  273,  274,  275,  276,   -1,   40,
   -1,   -1,  281,   -1,   45,   -1,  285,  286,  287,  257,
   -1,  290,  291,  292,  293,  294,  295,   -1,  297,  298,
  299,  300,  301,  302,  303,  304,  305,   -1,   -1,  123,
   -1,   -1,  126,   -1,  282,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  291,  292,  293,  294,  295,   40,   -1,
   -1,   -1,   -1,   45,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  309,  310,   -1,  312,  257,  258,  259,  260,   -1,
   -1,  319,  320,  321,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  273,  274,  275,  276,  126,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  287,   -1,  289,  290,  291,
  292,  293,  294,  295,   -1,  297,  298,  299,  300,  301,
  302,  303,  304,  305,   -1,   -1,   40,   -1,   -1,   -1,
   -1,   45,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  126,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  257,  258,  259,  260,   40,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  273,
  274,  275,  276,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  287,   -1,   -1,  290,  291,  292,  293,
  294,  295,  126,  297,  298,  299,  300,  301,  302,  303,
  304,  305,   -1,   -1,   -1,   -1,  257,  258,  259,  260,
   40,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  273,  274,  275,  276,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  287,   -1,  289,  290,
  291,  292,  293,  294,  295,   -1,  297,  298,  299,  300,
  301,  302,  303,  304,  305,  257,  258,  259,  260,   38,
   -1,   -1,   41,   42,   43,   44,   -1,   -1,   47,   -1,
   -1,  273,  274,  275,  276,   -1,   -1,   -1,   -1,   -1,
   59,   60,   61,   62,   -1,  287,   -1,   -1,  290,  291,
  292,  293,  294,  295,   -1,  297,  298,  299,  300,  301,
  302,  303,  304,  305,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   93,   94,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  257,  258,  259,  260,   38,   -1,   -1,
   -1,   42,   43,   -1,   45,   -1,   47,   -1,   -1,  273,
  274,  275,  276,   -1,   -1,  124,   -1,   -1,   -1,   60,
   61,   62,   -1,  287,   -1,   -1,  290,  291,  292,  293,
  294,  295,   -1,  297,  298,  299,  300,  301,  302,  303,
  304,  305,   -1,   -1,  257,   -1,  259,  260,   -1,   -1,
   -1,   -1,   -1,   94,   -1,   -1,   -1,   -1,   -1,   -1,
  273,  274,  275,  276,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  287,   -1,   -1,  290,  291,  292,
  293,  294,  295,  124,  297,  298,  299,  300,  301,  302,
  303,  304,  305,   -1,   -1,   -1,   -1,  257,   -1,  259,
  260,   -1,   38,   -1,   -1,   41,   42,   43,   44,   45,
   -1,   47,   -1,  273,  274,  275,  276,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   60,   61,   62,  287,   -1,   -1,
  290,  291,  292,  293,  294,  295,   -1,  297,  298,  299,
  300,  301,  302,  303,  304,  305,   -1,   -1,   -1,   -1,
   -1,   -1,  261,  262,  263,  264,  265,  266,   94,   38,
   -1,   -1,   -1,   42,   43,   -1,   45,   -1,   47,   -1,
   -1,   -1,   -1,  282,   -1,   -1,   -1,   -1,   -1,   -1,
   59,   60,   61,   62,   -1,   -1,   38,   -1,  124,   41,
   42,   43,   -1,   45,   38,   47,   -1,   41,   42,   43,
   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,   60,   61,
   62,   -1,   -1,   -1,   -1,   94,   60,   61,   62,   -1,
  261,  262,  263,  264,  265,  266,  267,   -1,   -1,   38,
   -1,   -1,   41,   42,   43,   -1,   45,   -1,   47,   -1,
   -1,   -1,   94,   -1,   -1,  124,   -1,   -1,   -1,   -1,
   94,   60,   61,   62,   38,   -1,   -1,   -1,   42,   43,
   44,   45,   -1,   47,   38,   -1,   -1,   41,   42,   43,
   -1,   45,  124,   47,   -1,   -1,   60,   61,   62,   -1,
  124,   -1,   -1,   -1,   -1,   94,   60,   61,   62,   38,
   -1,   -1,   -1,   42,   43,   44,   45,   -1,   47,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   94,   60,   61,   62,   -1,  124,   -1,   -1,   -1,   -1,
   94,   -1,   -1,   -1,   -1,  261,  262,  263,  264,  265,
  266,   -1,   -1,   -1,   -1,   -1,   -1,   38,   -1,   -1,
  124,   42,   43,   44,   45,   94,   47,   -1,   38,   -1,
  124,   41,   42,   43,   -1,   45,   -1,   47,   -1,   60,
   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   60,   61,   62,   -1,   -1,  124,   -1,   -1,   -1,   -1,
   -1,   -1,  261,  262,  263,  264,  265,  266,   -1,   -1,
   -1,   -1,   -1,   94,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   94,   -1,   -1,   -1,   -1,  261,
  262,  263,  264,  265,  266,   -1,   -1,  261,  262,  263,
  264,  265,  266,  124,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  124,   -1,   -1,   38,   -1,   -1,
   -1,   42,   43,   -1,   45,   -1,   47,   -1,   -1,   -1,
   -1,   -1,  261,  262,  263,  264,  265,  266,   -1,   60,
   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  261,  262,  263,
  264,  265,  266,   -1,   -1,   -1,   -1,  261,  262,  263,
  264,  265,  266,   94,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  261,  262,  263,  264,  265,  266,   -1,   -1,
   -1,   -1,   -1,  124,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  261,  262,  263,  264,  265,  266,   -1,   -1,   -1,   -1,
   -1,  261,  262,  263,  264,  265,  266,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  261,  262,  263,  264,  265,  266,
};
#define YYFINAL 34
#ifndef YYDEBUG
#define YYDEBUG 1
#endif
#define YYMAXTOKEN 321
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,"'&'",0,"'('","')'","'*'","'+'","','","'-'","'.'","'/'",0,0,0,0,0,0,0,0,
0,0,0,"';'","'<'","'='","'>'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,"'['",0,"']'","'^'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,"'{'","'|'","'}'","'~'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"SYMBOL","KEYWORD","LITERAL",
"STRING","COLON_EQUAL","GREATER_EQUAL","LESSER_EQUAL","NOT_EQUAL",
"NOT_EQUAL_EQUAL","EQUAL_EQUAL","EQUAL_ARROW","COLON_COLON","QUESTION_QUESTION",
"ELLIPSIS","UNRECOGNIZED","EOF_TOKEN","HASH_T","HASH_F","HASH_BRACKET",
"HASH_PAREN","HASH_NEXT","HASH_REST","HASH_KEY","HASH_ALL_KEYS","DEFINE","END",
"GENERIC","HANDLER","LET","LOCAL","METHOD","FUNCTION","OTHERWISE","CLASS",
"CONSTANT","LIBRARY","MODULE","VARIABLE","TEST","SLOT","BEGIN_TOKEN","CASE",
"IF","UNLESS","UNTIL","WHILE","BLOCK","FOR","SELECT","USE","EXPORT","CREATE",
"ELSE","ELSEIF","BY","FINALLY","THEN","IN","FROM","TO","ABOVE","BELOW",
"AFTERWARDS","CLEANUP","EXCEPTION",
};
char *yyrule[] = {
"$accept : evaluable_constituent",
"defining_word : CLASS",
"defining_word : CONSTANT",
"defining_word : LIBRARY",
"defining_word : MODULE",
"defining_word : VARIABLE",
"defining_word : TEST",
"evaluable_constituent : ';'",
"evaluable_constituent : defining_form ';'",
"evaluable_constituent : expression ';'",
"evaluable_constituent : local_declaration",
"evaluable_constituent : EOF_TOKEN",
"evaluable_constituent : error ';'",
"evaluable_constituent : error EOF_TOKEN",
"body :",
"body : nonempty_body",
"$$1 :",
"nonempty_body : $$1 nonempty_constituents",
"nonempty_constituents : constituent",
"nonempty_constituents : constituent ';' constituents",
"constituents :",
"constituents : constituent",
"constituents : constituent ';' constituents",
"constituent : defining_form",
"constituent : local_declaration",
"constituent : expression",
"expression : binary_operand",
"expression : expression COLON_EQUAL expression",
"expression : expression '&' expression",
"expression : expression '|' expression",
"expression : expression GREATER_EQUAL expression",
"expression : expression LESSER_EQUAL expression",
"expression : expression '<' expression",
"expression : expression '>' expression",
"expression : expression NOT_EQUAL expression",
"expression : expression NOT_EQUAL_EQUAL expression",
"expression : expression EQUAL_EQUAL expression",
"expression : expression '=' expression",
"expression : expression '-' expression",
"expression : expression '+' expression",
"expression : expression '/' expression",
"expression : expression '*' expression",
"expression : expression '^' expression",
"binary_operand : KEYWORD",
"binary_operand : keyless_binary_operand",
"keyless_binary_operand : operand",
"keyless_binary_operand : unary_operator operand",
"unary_operator : '-'",
"unary_operator : '~'",
"operand : operand '(' arguments_opt ')'",
"operand : operand '[' arguments_opt ']'",
"operand : operand '.' variable_name",
"operand : leaf",
"unparenthesized_operand : unparenthesized_operand '(' arguments_opt ')'",
"unparenthesized_operand : unparenthesized_operand '[' arguments ']'",
"unparenthesized_operand : unparenthesized_operand '.' variable_name",
"unparenthesized_operand : unparenthesized_leaf",
"arguments : KEYWORD expression",
"arguments : expression",
"arguments : KEYWORD expression ',' arguments",
"arguments : expression ',' arguments",
"leaf : '(' expression ')'",
"leaf : unparenthesized_leaf",
"unparenthesized_leaf : literal",
"unparenthesized_leaf : variable_name",
"unparenthesized_leaf : METHOD method_body END METHOD_opt",
"unparenthesized_leaf : statement",
"literal : LITERAL",
"literal : strings",
"literal : HASH_T",
"literal : HASH_F",
"literal : HASH_PAREN list_constants_opt ')'",
"literal : HASH_BRACKET constants_opt ']'",
"strings : STRING",
"strings : STRING component_strings",
"component_strings : STRING",
"component_strings : STRING component_strings",
"constants : constant",
"constants : constant ',' constants",
"list_constants : constant",
"list_constants : constant '.' constant",
"list_constants : constant ',' list_constants",
"constant : literal",
"constant : KEYWORD",
"statement : begin_statement",
"statement : if_statement",
"statement : unless_statement",
"statement : case_statement",
"statement : select_statement",
"statement : while_statement",
"statement : until_statement",
"statement : for_statement",
"statement : block_statement",
"$$2 :",
"begin_statement : BEGIN_TOKEN $$2 body END",
"$$3 :",
"$$4 :",
"if_statement : IF $$3 '(' expression ')' then_body else_parts $$4 END IF_opt",
"then_body :",
"then_body : nonempty_body",
"else_parts :",
"else_parts : ELSE",
"else_parts : ELSE nonempty_body",
"else_parts : ELSEIF '(' expression ')' body else_parts",
"unless_statement : UNLESS '(' expression ')' body END UNLESS_opt",
"case_statement : CASE case_body END CASE_opt",
"case_body :",
"$$5 :",
"case_body : case_label $$5 case_tail SEMICOLON_opt",
"case_tail :",
"case_tail : ';'",
"$$6 :",
"case_tail : ';' case_label $$6 case_tail",
"case_tail : constituent",
"case_tail : constituent ';' case_tail",
"$$7 :",
"case_tail : constituent ';' case_label $$7 case_tail",
"case_label : expression EQUAL_ARROW",
"case_label : OTHERWISE EQUAL_ARROW_opt",
"$$8 :",
"$$9 :",
"select_statement : SELECT $$8 '(' expression test_opt $$9 ')' select_body END SELECT_opt",
"test_opt :",
"test_opt : BY expression",
"select_body :",
"$$10 :",
"select_body : select_label $$10 select_tail SEMICOLON_opt",
"select_tail :",
"select_tail : ';'",
"$$11 :",
"select_tail : ';' select_label $$11 select_tail",
"select_tail : constituent",
"select_tail : constituent ';' select_tail",
"$$12 :",
"select_tail : constituent ';' select_label $$12 select_tail",
"select_label : expressions EQUAL_ARROW",
"select_label : '(' expression ',' expressions ')' EQUAL_ARROW",
"select_label : OTHERWISE EQUAL_ARROW_opt",
"while_statement : WHILE '(' expression ')' body END WHILE_opt",
"until_statement : UNTIL '(' expression ')' body END UNTIL_opt",
"$$13 :",
"$$14 :",
"$$15 :",
"for_statement : FOR $$13 '(' for_clauses_opt for_terminator_opt $$14 ')' body finally_opt END $$15 FOR_opt",
"for_clauses : for_clause comma_opt",
"for_clauses : for_clause ',' for_clauses",
"for_clauses_opt :",
"for_clauses_opt : for_clauses",
"for_clause : variable '=' expression THEN expression",
"for_clause : variable IN expression",
"for_clause : variable FROM expression bound_opt increment_clause_opt",
"bound_opt :",
"bound_opt : TO expression",
"bound_opt : ABOVE expression",
"bound_opt : BELOW expression",
"increment_clause_opt :",
"increment_clause_opt : BY expression",
"for_terminator_opt :",
"for_terminator_opt : UNTIL expression",
"for_terminator_opt : WHILE expression",
"for_terminator_opt : KEYWORD expression",
"finally_opt :",
"finally_opt : FINALLY body",
"$$16 :",
"$$17 :",
"block_statement : BLOCK $$16 '(' variable_name ')' body afterwards_opt cleanup_opt exceptions $$17 END BLOCK_opt",
"afterwards_opt :",
"afterwards_opt : AFTERWARDS body",
"cleanup_opt :",
"cleanup_opt : CLEANUP body",
"exceptions :",
"exceptions : exceptions EXCEPTION '(' exception_args ')' body",
"exception_args : variable_name",
"exception_args : variable_name COLON_COLON variable_name comma_arguments_opt",
"IF_opt :",
"IF_opt : IF",
"UNLESS_opt :",
"UNLESS_opt : UNLESS",
"CASE_opt :",
"CASE_opt : CASE",
"SELECT_opt :",
"SELECT_opt : SELECT",
"WHILE_opt :",
"WHILE_opt : WHILE",
"UNTIL_opt :",
"UNTIL_opt : UNTIL",
"FOR_opt :",
"FOR_opt : FOR",
"BLOCK_opt :",
"BLOCK_opt : BLOCK",
"defining_form : DEFINE modifiers_opt METHOD method_definition",
"defining_form : DEFINE modifiers_opt FUNCTION function_definition",
"defining_form : DEFINE modifiers_opt GENERIC generic_function_definition",
"defining_form : DEFINE VARIABLE bindings",
"defining_form : DEFINE CONSTANT bindings",
"$$18 :",
"defining_form : DEFINE modifiers_opt CLASS $$18 class_definition",
"$$19 :",
"defining_form : DEFINE MODULE $$19 module_definition",
"defining_form : DEFINE TEST SYMBOL '(' arguments_opt ')' body END TEST_opt variable_name_opt",
"class_definition : variable_name expression_list slot_specs END CLASS_opt variable_name_opt",
"slot_specs :",
"slot_specs : slot_spec",
"slot_specs : slot_spec ';' slot_specs",
"slot_spec : initialization_argument_spec",
"slot_spec : slot_modifiers_opt SLOT variable comma_arguments_opt",
"slot_modifiers_opt :",
"slot_modifiers_opt : SYMBOL slot_modifiers_opt",
"slot_modifiers_opt : CLASS slot_modifiers_opt",
"initialization_argument_spec : SYMBOL KEYWORD comma_arguments_opt",
"initialization_argument_spec : SYMBOL SYMBOL KEYWORD comma_arguments_opt",
"method_definition : variable_name method_body END METHOD_opt variable_name_opt",
"function_definition : variable_name method_body END FUNCTION_opt variable_name_opt",
"generic_function_definition : variable_name generic_function_body",
"module_definition : variable_name module_clauses END MODULE_opt variable_name_opt",
"module_clauses :",
"module_clauses : module_clause ';' module_clauses",
"module_clause : use_clause",
"module_clause : export_clause",
"module_clause : create_clause",
"use_clause : USE variable_name property_list_opt",
"export_clause : EXPORT item_names",
"create_clause : CREATE item_names",
"modifiers : SYMBOL",
"modifiers : SYMBOL modifiers",
"expression_list : '(' expressions_opt ')'",
"expressions : expression",
"expressions : expression ',' expressions",
"item_names : variable_name",
"item_names : variable_name ',' item_names",
"$$20 :",
"method_body : '(' parameter_list_opt ')' $$20 SEMICOLON_opt body",
"method_body : '(' parameter_list_opt ')' EQUAL_ARROW variable ';' body",
"method_body : '(' parameter_list_opt ')' EQUAL_ARROW '(' value_list_opt ')' SEMICOLON_opt body",
"generic_function_body : '(' parameter_list_opt ')'",
"generic_function_body : '(' parameter_list_opt ')' EQUAL_ARROW variable",
"generic_function_body : '(' parameter_list_opt ')' EQUAL_ARROW '(' value_list_opt ')'",
"parameter_list : parameter",
"parameter_list : parameter_list ',' parameter",
"parameter_list : parameter_list ',' next_rest_key_parameter_list",
"parameter_list : next_rest_key_parameter_list",
"next_rest_key_parameter_list : HASH_NEXT variable_name",
"next_rest_key_parameter_list : HASH_NEXT variable_name ',' rest_key_parameter_list",
"next_rest_key_parameter_list : rest_key_parameter_list",
"rest_key_parameter_list : HASH_REST variable_name",
"rest_key_parameter_list : HASH_REST variable_name ',' key_parameter_list",
"rest_key_parameter_list : key_parameter_list",
"key_parameter_list : HASH_KEY",
"key_parameter_list : HASH_KEY ',' HASH_ALL_KEYS",
"key_parameter_list : HASH_KEY keyword_parameters",
"key_parameter_list : HASH_ALL_KEYS",
"parameter : variable_name type_designator_opt",
"parameter : variable_name EQUAL_EQUAL expression",
"keyword_parameters : keyword_parameter",
"keyword_parameters : HASH_ALL_KEYS",
"keyword_parameters : keyword_parameter ',' keyword_parameters",
"keyword_parameter : KEYWORD variable_name type_designator_opt default_opt",
"keyword_parameter : variable_name type_designator_opt default_opt",
"default : '=' expression",
"local_declaration : LET bindings",
"local_declaration : LET HANDLER condition '=' handler",
"$$21 :",
"local_declaration : LOCAL $$21 local_methods",
"condition : unparenthesized_operand",
"condition : '(' type property_list_opt ')'",
"handler : expression",
"local_methods : METHOD_opt method_definition",
"$$22 :",
"local_methods : METHOD_opt method_definition ',' $$22 local_methods",
"bindings : variable '=' expression",
"bindings : '(' variable_list ')' '=' expression",
"variable_list : variable",
"variable_list : variable ',' variable_list",
"variable_list : HASH_REST variable_name",
"value_variable_list : variable",
"value_variable_list : variable ',' value_variable_list",
"value_variable_list : HASH_REST variable",
"variable : variable_name type_designator_opt",
"variable_name : SYMBOL",
"variable_name : defining_word",
"variable_name_opt :",
"variable_name_opt : variable_name",
"type_designator : COLON_COLON type",
"type : operand",
"property_list : property",
"property_list : property property_list",
"property : ',' KEYWORD value",
"value : expression",
"value : '{' property_set_opt '}'",
"property_set : property_set_member",
"property_set : property_set_member ',' property_set",
"property_set_member : property_set_item",
"property_set_member : property_set_item EQUAL_ARROW property_set_item",
"property_set_item : variable_name",
"EQUAL_ARROW_opt :",
"EQUAL_ARROW_opt : EQUAL_ARROW",
"METHOD_opt :",
"METHOD_opt : METHOD",
"FUNCTION_opt :",
"FUNCTION_opt : FUNCTION",
"CLASS_opt :",
"CLASS_opt : CLASS",
"TEST_opt :",
"TEST_opt : TEST",
"MODULE_opt :",
"MODULE_opt : MODULE",
"SEMICOLON_opt :",
"SEMICOLON_opt : ';'",
"comma_opt :",
"comma_opt : ','",
"comma_arguments_opt :",
"comma_arguments_opt : ',' arguments",
"arguments_opt :",
"arguments_opt : arguments",
"constants_opt :",
"constants_opt : constants",
"list_constants_opt :",
"list_constants_opt : list_constants",
"default_opt :",
"default_opt : default",
"expressions_opt :",
"expressions_opt : expressions",
"modifiers_opt :",
"modifiers_opt : modifiers",
"parameter_list_opt :",
"parameter_list_opt : parameter_list",
"property_list_opt :",
"property_list_opt : property_list",
"property_set_opt :",
"property_set_opt : property_set",
"type_designator_opt :",
"type_designator_opt : type_designator",
"value_list_opt :",
"value_list_opt : value_variable_list",
};
#endif
#ifndef YYSTYPE
typedef int YYSTYPE;
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH 500
#endif
#endif
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short yyss[YYSTACKSIZE];
YYSTYPE yyvs[YYSTACKSIZE];
#define yystacksize YYSTACKSIZE
#line 1366 "dylan.y"

void yyerror(char *s)
{
    char line_str[20];
    sprintf (line_str, " [line #%d]", yylineno);
    warning (s,
	     make_byte_string (yytext),
	     make_byte_string (line_str),
	     NULL);
}

/*
 * append_bang appends l2 to l1 if l1 is nonempty.
 * if l1 is empty, it just returns l2.
 */	
static Object
append_bang(Object l1, Object l2)
{
    Object res = l1;

    if (EMPTYLISTP (l1)) {
        return l2;
#if 0
	fprintf(stderr, "Whoa! append! to empty_list!\n");
	abort();
#endif
    }
    while (PAIRP (CDR (l1))) {
	l1 = CDR (l1);
    }
    CDR (l1) = l2;
    return res;
}

/*
 *  nelistem lists together objects with the following provisos:
 *  any objects aside from the first that are empty lists are not
 *  consed into the result.
 */
static Object
nelistem (Object car,...)
{
	Object fst, el, acons, cur;
	va_list args;

	fst = cur = acons = cons (car, make_empty_list ());
	va_start (args, car);
	el = va_arg (args, Object);

	while (el) {
	    if (!EMPTYLISTP (el)) {
		acons = cons (el, make_empty_list());
		CDR (cur) = acons;
		cur = acons;
	    }
	    el = va_arg (args, Object);
	}
	va_end (args);
	return (fst);
}
	    
static void
push_bindings()
{
    binding_stack = cons (make_integer(0), binding_stack);
}

static void
pop_bindings()
{
    binding_stack = CDR (binding_stack);
}


static Object
bindings_top ()
{
    return CAR (binding_stack);
}

static void
bindings_increment ()
{
    CAR (binding_stack) = make_integer (INTVAL (CAR (binding_stack)) + 1);
}

static Object
make_setter_expr (Object place, Object value)
{
    Object newsym;

    if ( ! PAIRP (place)) {
	error("Trying to make a setter from something that's not a place",
	      place, NULL);
    }
    newsym = gensym(1);
    return listem (unbinding_begin_symbol,
		   make_integer (1),
		   cons (local_bind_symbol,
			 cons(cons(cons(newsym,
					cons (value,
					      make_empty_list())),
				   make_empty_list()),
			      make_empty_list())),
		   cons (make_setter_symbol (FIRST (place)),
			 cons (newsym, CDR (place))),
		   newsym,
		   NULL);
}

#define	GENSYM_BUFSIZE	128
char gensymbuf[GENSYM_BUFSIZE];

static Object
gensym(int i)
{
    sprintf( gensymbuf, "\"tmp%d", i);
    return make_symbol (gensymbuf);
}

static int
allocation_word (Object word)
{
    return (id (word, instance_symbol) || id (word, class_symbol)
	    || id (word, each_subclass_symbol) || id (word, constant_symbol)
	    || id (word, virtual_symbol) || id (word, inherited_symbol));
}

#ifdef OPTIMIZE_SPECIALIZERS
static void
symtab_push_begin ()
{
    symtab = cons (make_table (DEFAULT_TABLE_SIZE), symtab);
}

static void
symtab_insert_bindings (Object bindings)
{
    Object variable;

#if 0
    warning ("Got symtab_insert_bindings", bindings, NULL);
#endif

    /*
     * bindings created by parser are always of form
     *  #( #( variable1, variable2, ... , variablen, values))
     */
    bindings = CAR (bindings);
    while ( !EMPTYLISTP (CDR (bindings))) {
	variable = CAR (bindings);
	if (PAIRP (variable)) {
#if 0
	    warning ("  symtab element",
		     CAR (variable),
		     SECOND (variable),
		     NULL);
#endif
	    table_element_setter (CAR (symtab),
				  CAR (variable),
				  SECOND (variable));
	}
	bindings = CDR (bindings);
    }
}

static void
symtab_push_parameters (Object parameters)
{
    Object variable;

    symtab = cons (make_table (DEFAULT_TABLE_SIZE), symtab);
#if 0
    warning ("Got symtab_insert_parameters", parameters, NULL);
#endif

    while (PAIRP (parameters)) {
	variable = CAR (parameters);
	if (! PAIRP (variable) && ! SYMBOLP (variable) ) {
	    /* we got to a keyword parameter or a hash-word */
	    break;
	}
	if (PAIRP (variable)) {
#if 0
   warning ("  symtab element",
		     CAR (variable),
		     SECOND (variable),
		     NULL);
#endif
	    table_element_setter (CAR (symtab),
				  CAR (variable),
				  SECOND (variable));
	}
	parameters = CDR (parameters);
    }
}

static void
symtab_pop ()
{
    symtab = CDR (symtab);
}
#endif
#line 2050 "y.tab.c"
#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
#if defined(__STDC__)
yyparse(void)
#else
yyparse()
#endif
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register char *yys;
    extern char *getenv();

    if (yys = getenv("YYDEBUG"))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yyss + yystacksize - 1)
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
    yyerror("syntax error");
#ifdef lint
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yyss + yystacksize - 1)
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 7:
#line 200 "dylan.y"
{ *parse_value_ptr = unspecified_object; YYACCEPT; }
break;
case 8:
#line 203 "dylan.y"
{ *parse_value_ptr = yyvsp[-1]; YYACCEPT; }
break;
case 9:
#line 206 "dylan.y"
{ *parse_value_ptr = yyvsp[-1]; YYACCEPT; }
break;
case 10:
#line 209 "dylan.y"
{ *parse_value_ptr = unspecified_object;
		  warning("local binding outside of block ignored", NULL);
		  YYACCEPT;
	        }
break;
case 11:
#line 218 "dylan.y"
{ *parse_value_ptr = eof_object; YYACCEPT; }
break;
case 12:
#line 221 "dylan.y"
{ yyerrok;
		  *parse_value_ptr = unspecified_object;
		  YYACCEPT;
		}
break;
case 13:
#line 226 "dylan.y"
{ yyerrok;
		  *parse_value_ptr = eof_object;
		  YYACCEPT;
		}
break;
case 14:
#line 232 "dylan.y"
{ yyval = unspecified_object; }
break;
case 15:
#line 233 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 16:
#line 236 "dylan.y"
{ push_bindings (); }
break;
case 17:
#line 240 "dylan.y"
{
	   if (INTVAL (bindings_top ()) > 0) {
	       yyval = cons(unbinding_begin_symbol,
			 cons (bindings_top(), yyvsp[0]));
	   } else if (list_length (yyvsp[0]) > 1) {
	       yyval = cons (begin_symbol, yyvsp[0]);
	   } else {
	       yyval = FIRST (yyvsp[0]);
	   }
	   pop_bindings ();
	}
break;
case 18:
#line 254 "dylan.y"
{ yyval = cons (yyvsp[0], make_empty_list()); }
break;
case 19:
#line 255 "dylan.y"
{ yyval = cons (yyvsp[-2], yyvsp[0]); }
break;
case 20:
#line 258 "dylan.y"
{ yyval = make_empty_list(); }
break;
case 21:
#line 259 "dylan.y"
{ yyval = cons (yyvsp[0], make_empty_list()); }
break;
case 22:
#line 260 "dylan.y"
{ yyval = cons (yyvsp[-2], yyvsp[0]); }
break;
case 23:
#line 267 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 24:
#line 268 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 25:
#line 269 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 26:
#line 277 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 27:
#line 280 "dylan.y"
{ if (SYMBOLP ( yyvsp[-2])) {
		 yyval = listem (set_bang_symbol, yyvsp[-2], yyvsp[0], NULL);
	     } else {
		 yyval = make_setter_expr (yyvsp[-2], yyvsp[0]);
	     }
	   }
break;
case 28:
#line 287 "dylan.y"
{ yyval = listem (yyvsp[-1], yyvsp[-2], yyvsp[0], NULL); }
break;
case 29:
#line 289 "dylan.y"
{ yyval = listem (yyvsp[-1], yyvsp[-2], yyvsp[0], NULL); }
break;
case 30:
#line 291 "dylan.y"
{ yyval = listem (yyvsp[-1], yyvsp[-2], yyvsp[0], NULL); }
break;
case 31:
#line 293 "dylan.y"
{ yyval = listem (yyvsp[-1], yyvsp[-2], yyvsp[0], NULL); }
break;
case 32:
#line 295 "dylan.y"
{ yyval = listem (yyvsp[-1], yyvsp[-2], yyvsp[0], NULL); }
break;
case 33:
#line 297 "dylan.y"
{ yyval = listem (yyvsp[-1], yyvsp[-2], yyvsp[0], NULL); }
break;
case 34:
#line 299 "dylan.y"
{ yyval = listem (yyvsp[-1], yyvsp[-2], yyvsp[0], NULL); }
break;
case 35:
#line 301 "dylan.y"
{ yyval = listem (yyvsp[-1], yyvsp[-2], yyvsp[0], NULL); }
break;
case 36:
#line 303 "dylan.y"
{ yyval = listem (yyvsp[-1], yyvsp[-2], yyvsp[0], NULL); }
break;
case 37:
#line 305 "dylan.y"
{ yyval = listem (yyvsp[-1], yyvsp[-2], yyvsp[0], NULL); }
break;
case 38:
#line 307 "dylan.y"
{ yyval = listem (yyvsp[-1], yyvsp[-2], yyvsp[0], NULL); }
break;
case 39:
#line 309 "dylan.y"
{ yyval = listem (yyvsp[-1], yyvsp[-2], yyvsp[0], NULL); }
break;
case 40:
#line 311 "dylan.y"
{ yyval = listem (yyvsp[-1], yyvsp[-2], yyvsp[0], NULL); }
break;
case 41:
#line 313 "dylan.y"
{ yyval = listem (yyvsp[-1], yyvsp[-2], yyvsp[0], NULL); }
break;
case 42:
#line 315 "dylan.y"
{ yyval = listem (yyvsp[-1], yyvsp[-2], yyvsp[0], NULL); }
break;
case 43:
#line 322 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 44:
#line 323 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 45:
#line 326 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 46:
#line 328 "dylan.y"
{ yyval = cons (yyvsp[-1], cons (yyvsp[0], make_empty_list())); }
break;
case 47:
#line 331 "dylan.y"
{ yyval = negative_symbol; }
break;
case 48:
#line 332 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 49:
#line 336 "dylan.y"
{   
#ifdef OPTIMIZE_SPECIALIZERS
	      yyval = cons (yyvsp[-3], yyvsp[-1]);
#else
	      yyval = cons (yyvsp[-3], yyvsp[-1]);
#endif
	  }
break;
case 50:
#line 344 "dylan.y"
{ if (list_length (yyvsp[-1]) == 1) {
			yyval = cons (element_symbol, cons (yyvsp[-3], yyvsp[-1]));
		  } else {
			yyval = cons (aref_symbol, cons (yyvsp[-3], yyvsp[-1]));
		  }
		}
break;
case 51:
#line 351 "dylan.y"
{ yyval = cons (yyvsp[0], cons (yyvsp[-2], make_empty_list())); }
break;
case 52:
#line 352 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 53:
#line 356 "dylan.y"
{   
#ifdef OPTIMIZE_SPECIALIZERS
		    yyval = cons (yyvsp[-3], yyvsp[-1]);
#else
		    yyval = cons (yyvsp[-3], yyvsp[-1]);
#endif
		}
break;
case 54:
#line 364 "dylan.y"
{ yyval = cons (element_symbol, cons (yyvsp[-3], yyvsp[-1])); }
break;
case 55:
#line 366 "dylan.y"
{ yyval = cons (yyvsp[0], cons (yyvsp[-2], make_empty_list())); }
break;
case 56:
#line 367 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 57:
#line 370 "dylan.y"
{ yyval = listem (yyvsp[-1], yyvsp[0], NULL); }
break;
case 58:
#line 371 "dylan.y"
{ yyval = cons (yyvsp[0], make_empty_list()); }
break;
case 59:
#line 373 "dylan.y"
{ yyval = cons (yyvsp[-3], cons (yyvsp[-2], yyvsp[0])); }
break;
case 60:
#line 375 "dylan.y"
{ yyval = cons (yyvsp[-2], yyvsp[0]); }
break;
case 61:
#line 377 "dylan.y"
{ yyval = yyvsp[-1]; }
break;
case 62:
#line 378 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 63:
#line 381 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 64:
#line 382 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 65:
#line 384 "dylan.y"
{ yyval = cons (yyvsp[-3], yyvsp[-2]); }
break;
case 66:
#line 385 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 67:
#line 387 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 68:
#line 388 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 69:
#line 389 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 70:
#line 390 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 71:
#line 392 "dylan.y"
{ yyval = yyvsp[-1]; }
break;
case 72:
#line 394 "dylan.y"
{ yyval = make_sov (yyvsp[-1]); }
break;
case 73:
#line 396 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 74:
#line 398 "dylan.y"
{ yyval = cons (concatenate_symbol, cons (yyvsp[-1], yyvsp[0])); }
break;
case 75:
#line 401 "dylan.y"
{ yyval = cons (yyvsp[0], make_empty_list()); }
break;
case 76:
#line 403 "dylan.y"
{ yyval = cons (yyvsp[-1], yyvsp[0]); }
break;
case 77:
#line 405 "dylan.y"
{ yyval = cons (yyvsp[0], make_empty_list()); }
break;
case 78:
#line 406 "dylan.y"
{ yyval = cons (yyvsp[-2], yyvsp[0]); }
break;
case 79:
#line 409 "dylan.y"
{ yyval = listem (pair_symbol,
						       yyvsp[0],
						       make_empty_list(),
						       NULL);
					}
break;
case 80:
#line 414 "dylan.y"
{ yyval = listem (pair_symbol, yyvsp[-2], yyvsp[0], NULL);
					}
break;
case 81:
#line 416 "dylan.y"
{ yyval = listem (pair_symbol, yyvsp[-2], yyvsp[0], NULL);
					}
break;
case 82:
#line 420 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 83:
#line 421 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 84:
#line 427 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 85:
#line 428 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 86:
#line 429 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 87:
#line 430 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 88:
#line 431 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 89:
#line 432 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 90:
#line 433 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 91:
#line 434 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 92:
#line 435 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 93:
#line 443 "dylan.y"
{ 
#ifdef OPTIMIZE_SPECIALIZERS
		    symtab_push_begin ();
#endif
		}
break;
case 94:
#line 449 "dylan.y"
{
#ifdef OPTIMIZE_SPECIALIZERS
		    symtab_pop ();
#endif
		    yyval = yyvsp[-1];
		}
break;
case 95:
#line 458 "dylan.y"
{ push_intermediate_words (yyvsp[0]); }
break;
case 96:
#line 461 "dylan.y"
{ pop_intermediate_words (); }
break;
case 97:
#line 463 "dylan.y"
{ yyval = cons (yyvsp[-9],
				     cons (yyvsp[-6],
					   append_bang (cons (yyvsp[-4],
							      make_empty_list()),
							yyvsp[-3]))); }
break;
case 98:
#line 470 "dylan.y"
{ yyval = false_object; }
break;
case 99:
#line 471 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 100:
#line 474 "dylan.y"
{ yyval = cons(false_object, make_empty_list()); }
break;
case 101:
#line 475 "dylan.y"
{ yyval = cons (false_object, make_empty_list()); }
break;
case 102:
#line 476 "dylan.y"
{ yyval = cons (yyvsp[0], make_empty_list()); }
break;
case 103:
#line 478 "dylan.y"
{ yyval = cons (cons (if_symbol,
					   cons (yyvsp[-3],
						 append_bang (cons (yyvsp[-1],
								    make_empty_list()),
							      yyvsp[0]))),
				     make_empty_list()); }
break;
case 104:
#line 488 "dylan.y"
{ yyval = cons (yyvsp[-6], cons (yyvsp[-4], cons (yyvsp[-2], make_empty_list()))); }
break;
case 105:
#line 494 "dylan.y"
{ yyval = cons (cond_symbol, yyvsp[-2]); }
break;
case 106:
#line 497 "dylan.y"
{ yyval = make_empty_list(); }
break;
case 107:
#line 499 "dylan.y"
{ push_bindings (); }
break;
case 108:
#line 501 "dylan.y"
{ yyval =  cons (cons (yyvsp[-3], !EMPTYLISTP (CAR (yyvsp[-1]))
				  ? cons (cons (unbinding_begin_symbol,
					        cons (bindings_top (),
						      CAR (yyvsp[-1]))),
				          make_empty_list())
				  : make_empty_list()),
		        CDR (yyvsp[-1]));
          }
break;
case 109:
#line 512 "dylan.y"
{ yyval = cons (make_empty_list(), make_empty_list()); }
break;
case 110:
#line 513 "dylan.y"
{ yyval = cons (make_empty_list(), make_empty_list()); }
break;
case 111:
#line 515 "dylan.y"
{ push_bindings (); }
break;
case 112:
#line 517 "dylan.y"
{ yyval = cons (make_empty_list(),
		     cons (cons (yyvsp[-2], !EMPTYLISTP (CAR (yyvsp[0]))
				     ? cons (cons (unbinding_begin_symbol,
					           cons (bindings_top(),
							 CAR (yyvsp[0]))),
				             make_empty_list())
				     : make_empty_list()),
		          CDR (yyvsp[0])));
	  pop_bindings ();
      }
break;
case 113:
#line 529 "dylan.y"
{ yyval = cons (cons (yyvsp[0], make_empty_list()), make_empty_list()); }
break;
case 114:
#line 532 "dylan.y"
{
		 yyval = cons (cons (yyvsp[-2], FIRST (yyvsp[0])), CDR (yyvsp[0]));
		}
break;
case 115:
#line 535 "dylan.y"
{ push_bindings(); }
break;
case 116:
#line 537 "dylan.y"
{ yyval = cons (cons (yyvsp[-4], make_empty_list()), 
		     cons ( cons(yyvsp[-2], !EMPTYLISTP (CAR (yyvsp[0]))
				     ? cons (cons (unbinding_begin_symbol,
						   cons (bindings_top(),
						         CAR (yyvsp[0]))),
					     make_empty_list())
				     : make_empty_list()),
			   CDR (yyvsp[0])));
		  pop_bindings ();
	      }
break;
case 117:
#line 553 "dylan.y"
{ yyval = yyvsp[-1]; }
break;
case 118:
#line 555 "dylan.y"
{ yyval = else_keyword; }
break;
case 119:
#line 558 "dylan.y"
{ push_intermediate_words (yyvsp[0]); }
break;
case 120:
#line 560 "dylan.y"
{ pop_intermediate_words (); }
break;
case 121:
#line 563 "dylan.y"
{ yyval = cons (yyvsp[-9], cons (yyvsp[-6], cons (yyvsp[-5] ? yyvsp[-5] : equal_equal_symbol,
						 yyvsp[-2]))); }
break;
case 122:
#line 567 "dylan.y"
{ yyval = NULL; }
break;
case 123:
#line 568 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 124:
#line 570 "dylan.y"
{ yyval = make_empty_list(); }
break;
case 125:
#line 572 "dylan.y"
{ push_bindings (); }
break;
case 126:
#line 574 "dylan.y"
{ yyval =  cons (cons (yyvsp[-3], !EMPTYLISTP (CAR (yyvsp[-1]))
				  ? cons (cons (unbinding_begin_symbol,
						cons (bindings_top (),
						      CAR (yyvsp[-1]))),
				          make_empty_list())
				  : make_empty_list()),
		      CDR (yyvsp[-1]));
          }
break;
case 127:
#line 584 "dylan.y"
{ yyval = cons (make_empty_list(), make_empty_list()); }
break;
case 128:
#line 585 "dylan.y"
{ yyval = cons (make_empty_list(), make_empty_list()); }
break;
case 129:
#line 587 "dylan.y"
{ push_bindings (); }
break;
case 130:
#line 589 "dylan.y"
{ yyval = cons (make_empty_list(),
		     cons (cons (yyvsp[-2], !EMPTYLISTP (CAR (yyvsp[0]))
				     ? cons (cons (unbinding_begin_symbol,
					           cons (bindings_top(),
							 CAR (yyvsp[0]))),
				    	     make_empty_list())
				     : make_empty_list()),
		           CDR (yyvsp[0])));
	  pop_bindings ();
      }
break;
case 131:
#line 601 "dylan.y"
{ yyval = cons (cons (yyvsp[0], make_empty_list()), make_empty_list()); }
break;
case 132:
#line 604 "dylan.y"
{
		 yyval = cons (cons (yyvsp[-2], FIRST (yyvsp[0])), CDR (yyvsp[0]));
		}
break;
case 133:
#line 607 "dylan.y"
{ push_bindings(); }
break;
case 134:
#line 609 "dylan.y"
{ yyval = cons (cons (yyvsp[-4], make_empty_list()), 
		     cons ( cons(yyvsp[-2], !EMPTYLISTP (CAR (yyvsp[0]))
				     ? cons (cons (unbinding_begin_symbol,
						   cons (bindings_top(),
						         CAR (yyvsp[0]))),
					     make_empty_list())
				     : make_empty_list()),
			   CDR (yyvsp[0])));
		  pop_bindings ();
	      }
break;
case 135:
#line 625 "dylan.y"
{ yyval = yyvsp[-1]; }
break;
case 136:
#line 627 "dylan.y"
{  yyval = cons (yyvsp[-4], yyvsp[-2]); }
break;
case 137:
#line 629 "dylan.y"
{ yyval = else_keyword; }
break;
case 138:
#line 633 "dylan.y"
{ yyval = cons (yyvsp[-6], cons (yyvsp[-4], cons (yyvsp[-2], make_empty_list()))); }
break;
case 139:
#line 637 "dylan.y"
{ yyval = cons (yyvsp[-6], cons (yyvsp[-4], cons (yyvsp[-2], make_empty_list()))); }
break;
case 140:
#line 640 "dylan.y"
{ push_intermediate_words (yyvsp[0]); }
break;
case 141:
#line 643 "dylan.y"
{ pop_intermediate_words (); }
break;
case 142:
#line 645 "dylan.y"
{ pop_intermediate_words (); }
break;
case 143:
#line 646 "dylan.y"
{ yyval = listem (for_symbol,	
			       yyvsp[-8],
			       append_bang(yyvsp[-7], yyvsp[-3]),
			       yyvsp[-4],
			       NULL);
		}
break;
case 144:
#line 653 "dylan.y"
{ yyval = cons (yyvsp[-1], make_empty_list()); }
break;
case 145:
#line 654 "dylan.y"
{ yyval = cons (yyvsp[-2], yyvsp[0]); }
break;
case 146:
#line 657 "dylan.y"
{ yyval = make_empty_list(); }
break;
case 147:
#line 658 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 148:
#line 662 "dylan.y"
{ yyval = cons (yyvsp[-4], cons (yyvsp[-2], cons (yyvsp[0], make_empty_list()))); }
break;
case 149:
#line 664 "dylan.y"
{ yyval = cons (collection_keyword,
			 cons (yyvsp[-2], cons (yyvsp[0], make_empty_list()))); }
break;
case 150:
#line 667 "dylan.y"
{ yyval = cons (range_keyword,
			     cons (yyvsp[-4],
				   cons (yyvsp[-2],
					 append_bang(yyvsp[-1], yyvsp[0])))); }
break;
case 151:
#line 673 "dylan.y"
{ yyval = make_empty_list(); }
break;
case 152:
#line 675 "dylan.y"
{ yyval = cons (yyvsp[-1], cons (yyvsp[0], make_empty_list())); }
break;
case 153:
#line 677 "dylan.y"
{ yyval = cons (yyvsp[-1], cons (yyvsp[0], make_empty_list())); }
break;
case 154:
#line 679 "dylan.y"
{ yyval = cons (yyvsp[-1], cons (yyvsp[0], make_empty_list())); }
break;
case 155:
#line 682 "dylan.y"
{ yyval = make_empty_list(); }
break;
case 156:
#line 684 "dylan.y"
{ yyval = cons (yyvsp[-1], cons (yyvsp[0], make_empty_list())); }
break;
case 157:
#line 687 "dylan.y"
{ yyval = cons (false_object,
					     make_empty_list()); }
break;
case 158:
#line 689 "dylan.y"
{ yyval = cons (yyvsp[0], make_empty_list()); }
break;
case 159:
#line 690 "dylan.y"
{ yyval = cons (cons (not_symbol,
					           cons (yyvsp[0],
                                                         make_empty_list())),
                                             make_empty_list()); }
break;
case 160:
#line 694 "dylan.y"
{ if (yyvsp[-1] == until_keyword) {
				      yyval =cons (yyvsp[0], make_empty_list());
				  } else if (yyvsp[-1] == while_keyword) {
				      yyval = cons (cons (not_symbol,
						       cons (yyvsp[0],
							     make_empty_list())),
					         make_empty_list());
				  } else {
					error ("Bogus keyword in if",
						yyvsp[-1],
						NULL);
				  }
				}
break;
case 161:
#line 709 "dylan.y"
{ yyval = make_empty_list(); }
break;
case 162:
#line 710 "dylan.y"
{ yyval = cons (yyvsp[0], make_empty_list()); }
break;
case 163:
#line 713 "dylan.y"
{ push_intermediate_words (yyvsp[0]); }
break;
case 164:
#line 719 "dylan.y"
{ pop_intermediate_words (); 
			  if (! EMPTYLISTP (yyvsp[0])) {
				warning ("Exceptions not yet implemented!",
					 NULL);
				}
			}
break;
case 165:
#line 727 "dylan.y"
{ yyval = listem (bind_exit_symbol,
			       cons (yyvsp[-8], make_empty_list()),
                               nelistem(unwind_protect_symbol,
					nelistem (bind_symbol,
					       cons (listem (hash_rest_symbol,
							       vals_symbol,
							       yyvsp[-6],
							       NULL),
						     make_empty_list()),
					       yyvsp[-5],
					       listem (apply_symbol,
						       yyvsp[-8],
						       vals_symbol,
						       NULL),
					       NULL),
					yyvsp[-4],
					NULL),
				NULL);
		}
break;
case 166:
#line 748 "dylan.y"
{ yyval = make_empty_list(); }
break;
case 167:
#line 749 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 168:
#line 752 "dylan.y"
{ yyval = make_empty_list(); }
break;
case 169:
#line 753 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 170:
#line 756 "dylan.y"
{ yyval = make_empty_list(); }
break;
case 171:
#line 760 "dylan.y"
{ yyval = cons (listem (yyvsp[-4], yyvsp[-2], yyvsp[0], NULL), yyvsp[-5]); }
break;
case 172:
#line 763 "dylan.y"
{ yyval = cons (yyvsp[0], make_empty_list()); }
break;
case 173:
#line 765 "dylan.y"
{ yyval = cons (cons (yyvsp[-3], cons (yyvsp[-1], make_empty_list())), yyvsp[0]); }
break;
case 190:
#line 802 "dylan.y"
{ yyval = cons (define_method_symbol, yyvsp[0]); }
break;
case 191:
#line 806 "dylan.y"
{ yyval = cons (define_function_symbol, yyvsp[0]); }
break;
case 192:
#line 810 "dylan.y"
{ yyval = cons (define_generic_function_symbol, yyvsp[0]); }
break;
case 193:
#line 815 "dylan.y"
{ yyval = cons (define_variable_symbol, CAR (yyvsp[0])); }
break;
case 194:
#line 818 "dylan.y"
{ yyval = cons (define_constant_symbol, CAR (yyvsp[0])); }
break;
case 195:
#line 821 "dylan.y"
{ push_intermediate_words (yyvsp[0]); }
break;
case 196:
#line 823 "dylan.y"
{ pop_intermediate_words ();
		  if (EMPTYLISTP (yyvsp[-3])) {
			yyval = cons (define_class_symbol, yyvsp[0]); 
		  } else {
			yyval = cons (define_class_symbol,
				   cons (cons (modifiers_keyword,
					       yyvsp[-3]),
					 yyvsp[0]));
		  }
		}
break;
case 197:
#line 838 "dylan.y"
{ push_intermediate_words (yyvsp[0]); }
break;
case 198:
#line 840 "dylan.y"
{ yyval = cons (define_module_symbol, yyvsp[0]); }
break;
case 199:
#line 844 "dylan.y"
{ yyval = listem (define_test_symbol, yyvsp[-7], yyvsp[-5],
			       empty_string, yyvsp[-3], NULL); }
break;
case 200:
#line 850 "dylan.y"
{ yyval = cons (yyvsp[-5], cons (yyvsp[-4], yyvsp[-3])); }
break;
case 201:
#line 853 "dylan.y"
{ yyval = make_empty_list(); }
break;
case 202:
#line 854 "dylan.y"
{ yyval = cons (yyvsp[0], make_empty_list()); }
break;
case 203:
#line 855 "dylan.y"
{ yyval = cons (yyvsp[-2], yyvsp[0]); }
break;
case 204:
#line 859 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 205:
#line 862 "dylan.y"
{ Object mods, mod;
		  Object allocation, getter_name, slot_type, dynamism;
		  int dynamism_specified = 0, allocation_specified = 0;
		  int slot_type_specified = 0;

		  slot_type = cons (type_keyword,
				    cons (CLASSNAME (object_class),
					  make_empty_list()));
		  allocation = cons (allocation_keyword,
				     cons (instance_symbol,
					   make_empty_list()));
		  dynamism = cons (dynamism_keyword,
				   cons (open_symbol,
					 make_empty_list()));
		  if (PAIRP (yyvsp[-1])) {
		      getter_name = CAR (yyvsp[-1]);
		      slot_type_specified = 1;
		      SECOND (slot_type) = SECOND (yyvsp[-1]);
		  } else {
		      getter_name = yyvsp[-1];
		  }
		  mods = yyvsp[-3];
		  while ( PAIRP (mods)) {
		      mod = CAR (mods);
		      if (id (mod, open_symbol)) {
			  if (dynamism_specified) {
			      error ("Slot dyanamism specified twice", NULL);
			  }
			  dynamism_specified = 1;
		      } else if (id (mod, sealed_symbol)) {
			  if (dynamism_specified) {
			      error ("Slot dyanamism specified twice", NULL);
			  }
			  SECOND (dynamism) = sealed_symbol;
		      } else if (allocation_word (mod)) {
			  if (allocation_specified) {
			      error ("Slot allocation specified twice", NULL);
			  }
			  allocation_specified = 1;
			  SECOND (allocation) = mod;
			  if ( ! EMPTYLISTP (CDR (mods))) {
			      error ("Slot modifiers follow allocation",
				     mods, NULL);
			  }
		      }
		      mods = CDR (mods);
		  }
		  yyval = cons (getter_name, yyvsp[0]);
		  if (slot_type_specified) {
		      append_bang (yyval, slot_type);
		  }
		  if (allocation_specified) {
		      append_bang (yyval, allocation);
		  }
		  if (dynamism_specified) {
		      append_bang (yyval, dynamism);
		  }
		}
break;
case 206:
#line 922 "dylan.y"
{ yyval = make_empty_list(); }
break;
case 207:
#line 923 "dylan.y"
{ yyval = cons (yyvsp[-1], yyvsp[0]); }
break;
case 208:
#line 924 "dylan.y"
{ yyval = cons (yyvsp[-1], yyvsp[0]); }
break;
case 209:
#line 928 "dylan.y"
{
		  if (yyvsp[-2] != keyword_symbol) {
			error ("Bad initialization argument specification", NULL);
		  } else {
			yyval = cons (init_keyword_keyword, cons (yyvsp[-1], yyvsp[0]));
		  }
		}
break;
case 210:
#line 936 "dylan.y"
{
		  if (yyvsp[-3] != required_symbol || yyvsp[-2] != keyword_symbol) {
			error ("Bad initialization argument specification", NULL);
		  } else {
			yyval = cons (required_init_keyword_keyword,
				cons (yyvsp[-1], yyvsp[0]));
		  }
		}
break;
case 211:
#line 947 "dylan.y"
{ yyval = cons (yyvsp[-4], yyvsp[-3]); }
break;
case 212:
#line 951 "dylan.y"
{ yyval = cons (yyvsp[-4], yyvsp[-3]); }
break;
case 213:
#line 955 "dylan.y"
{ yyval = cons (yyvsp[-1], yyvsp[0]); }
break;
case 214:
#line 963 "dylan.y"
{ yyval = cons (yyvsp[-4], yyvsp[-3]); }
break;
case 215:
#line 966 "dylan.y"
{ yyval = make_empty_list(); }
break;
case 216:
#line 968 "dylan.y"
{ yyval = cons (yyvsp[-2], yyvsp[0]); }
break;
case 217:
#line 971 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 218:
#line 972 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 219:
#line 973 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 220:
#line 977 "dylan.y"
{ yyval = cons (yyvsp[-2], cons (yyvsp[-1], yyvsp[0])); }
break;
case 221:
#line 980 "dylan.y"
{ yyval = cons (yyvsp[-1], yyvsp[0]); }
break;
case 222:
#line 982 "dylan.y"
{ yyval = cons (yyvsp[-1], yyvsp[0]); }
break;
case 223:
#line 985 "dylan.y"
{ yyval = cons (yyvsp[0], make_empty_list()); }
break;
case 224:
#line 986 "dylan.y"
{ yyval = cons (yyvsp[-1], yyvsp[0]); }
break;
case 225:
#line 989 "dylan.y"
{ yyval = yyvsp[-1]; }
break;
case 226:
#line 992 "dylan.y"
{ yyval = cons (yyvsp[0], make_empty_list()); }
break;
case 227:
#line 993 "dylan.y"
{ yyval = cons ( yyvsp[-2], yyvsp[0]); }
break;
case 228:
#line 1012 "dylan.y"
{ yyval = cons (yyvsp[0], make_empty_list()); }
break;
case 229:
#line 1013 "dylan.y"
{ yyval = cons (yyvsp[-2], yyvsp[0]); }
break;
case 230:
#line 1020 "dylan.y"
{   
#ifdef OPTIMIZE_SPECIALIZERS
		    symtab_push_parameters (yyvsp[-1]);
#endif
		}
break;
case 231:
#line 1026 "dylan.y"
{   
#ifdef OPTIMIZE_SPECIALIZERS
		    symtab_pop ();
#endif
		    yyval = cons (yyvsp[-4], cons (yyvsp[0], make_empty_list()));
		}
break;
case 232:
#line 1033 "dylan.y"
{ yyval = cons (append_bang (yyvsp[-5],
					  cons (hash_values_symbol,
						cons (yyvsp[-2], make_empty_list()))),
			     cons (yyvsp[0], make_empty_list())); }
break;
case 233:
#line 1039 "dylan.y"
{ yyval = cons (append_bang (yyvsp[-7],
					  cons (hash_values_symbol, yyvsp[-3])),
			     cons ( yyvsp[0], make_empty_list())); }
break;
case 234:
#line 1044 "dylan.y"
{ yyval = cons (yyvsp[-1], make_empty_list()); }
break;
case 235:
#line 1046 "dylan.y"
{ yyval = cons (append_bang (yyvsp[-3], cons (hash_values_symbol,
					      cons (yyvsp[0], make_empty_list()))),
			     make_empty_list()); }
break;
case 236:
#line 1050 "dylan.y"
{ yyval = cons (append_bang (yyvsp[-5], cons (hash_values_symbol, yyvsp[-1])),
		 	     make_empty_list()); }
break;
case 237:
#line 1054 "dylan.y"
{ yyval = cons (yyvsp[0], make_empty_list()); }
break;
case 238:
#line 1056 "dylan.y"
{ yyval = append_bang (yyvsp[-2], cons (yyvsp[0], make_empty_list())); }
break;
case 239:
#line 1058 "dylan.y"
{ yyval = append_bang (yyvsp[-2], yyvsp[0]); }
break;
case 240:
#line 1060 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 241:
#line 1064 "dylan.y"
{ yyval = cons (yyvsp[-1], cons (yyvsp[0], make_empty_list())); }
break;
case 242:
#line 1066 "dylan.y"
{ yyval = cons (yyvsp[-3], cons (yyvsp[-2], yyvsp[0])); }
break;
case 243:
#line 1068 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 244:
#line 1072 "dylan.y"
{ yyval = cons (yyvsp[-1], cons (yyvsp[0], make_empty_list())); }
break;
case 245:
#line 1074 "dylan.y"
{ yyval = cons (yyvsp[-3], cons (yyvsp[-2], yyvsp[0])); }
break;
case 246:
#line 1076 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 247:
#line 1079 "dylan.y"
{ yyval = cons (yyvsp[0], make_empty_list()); }
break;
case 248:
#line 1081 "dylan.y"
{ yyval = cons (yyvsp[-2], cons (yyvsp[0], make_empty_list())); }
break;
case 249:
#line 1083 "dylan.y"
{ yyval = cons (yyvsp[-1], yyvsp[0]); }
break;
case 250:
#line 1085 "dylan.y"
{ yyval = cons (yyvsp[0], make_empty_list()); }
break;
case 251:
#line 1089 "dylan.y"
{ yyval = (yyvsp[0] ? cons (yyvsp[-1], cons (yyvsp[0], make_empty_list()))
			: yyvsp[-1]);
		}
break;
case 252:
#line 1093 "dylan.y"
{ yyval = cons (yyvsp[-2], cons (cons (singleton_symbol,
					     cons (yyvsp[0], make_empty_list())),
				       make_empty_list())); }
break;
case 253:
#line 1098 "dylan.y"
{ yyval = cons (yyvsp[0], make_empty_list()); }
break;
case 254:
#line 1099 "dylan.y"
{ yyval = cons (yyvsp[0], make_empty_list()); }
break;
case 255:
#line 1101 "dylan.y"
{ yyval = cons (yyvsp[-2], yyvsp[0]); }
break;
case 256:
#line 1106 "dylan.y"
{ Object variable = yyvsp[-1] == NULL? yyvsp[-2]
                                              : listem (yyvsp[-2], yyvsp[-1], NULL);
		  if (yyvsp[0]) {
		    if (yyvsp[-3]) {
			yyval =cons (yyvsp[-3], cons (variable,
					    cons(yyvsp[0], make_empty_list())));
		    } else {
			yyval = cons (variable,
				   cons (yyvsp[0], make_empty_list ()));
		    }
		  } else {
		      yyval = cons (yyvsp[-3], cons (variable, make_empty_list()));
		  }
		}
break;
case 257:
#line 1122 "dylan.y"
{ Object variable = yyvsp[-1] == NULL? yyvsp[-2]
					      : listem (yyvsp[-2], yyvsp[-1], NULL);
		  if (yyvsp[0]) {
		    yyval = cons (variable, cons (yyvsp[0], make_empty_list()));
		} else {
		    yyval = variable;
		}
	       }
break;
case 258:
#line 1131 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 259:
#line 1153 "dylan.y"
{   bindings_increment ();
#ifdef OPTIMIZE_SPECIALIZERS
		    symtab_insert_bindings (yyvsp[0]);
#endif
		    yyval = cons (local_bind_symbol,
			       cons (yyvsp[0], make_empty_list()));
		}
break;
case 261:
#line 1161 "dylan.y"
{ methnames = methdefs = make_empty_list(); }
break;
case 262:
#line 1164 "dylan.y"
{   Object methbindings = cons (append (methnames,
						  cons (cons (values_symbol,
							      methdefs),
							make_empty_list())),
					  make_empty_list()); 
#ifdef OPTIMIZE_SPECIALIZERS
	      symtab_insert_bindings (methbindings);
#endif
	      bindings_increment ();
	      yyval = cons (local_bind_rec_symbol,
			 cons ( methbindings,
			       make_empty_list()));
	  }
break;
case 263:
#line 1180 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 265:
#line 1183 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 266:
#line 1187 "dylan.y"
{
		 methnames = cons (FIRST (yyvsp[0]), methnames);
		 methdefs = cons (cons (method_symbol, CDR (yyvsp[0])), methdefs);
		}
break;
case 267:
#line 1192 "dylan.y"
{
		 methnames = cons (FIRST (yyvsp[-1]), methnames); 
		 methdefs = cons (cons (method_symbol, CDR (yyvsp[-1])), methdefs);
		}
break;
case 269:
#line 1200 "dylan.y"
{ yyval = cons (cons (yyvsp[-2], cons (yyvsp[0], make_empty_list())),
			     make_empty_list()); }
break;
case 270:
#line 1203 "dylan.y"
{ yyval = cons (append_bang (yyvsp[-3], cons (yyvsp[0], make_empty_list())),
			     make_empty_list()); }
break;
case 271:
#line 1207 "dylan.y"
{ yyval = cons (yyvsp[0], make_empty_list()); }
break;
case 272:
#line 1209 "dylan.y"
{ yyval = cons (yyvsp[-2], yyvsp[0]); }
break;
case 273:
#line 1211 "dylan.y"
{ yyval = cons (yyvsp[-1], cons (yyvsp[0], make_empty_list())); }
break;
case 274:
#line 1215 "dylan.y"
{ yyval = cons (yyvsp[0], make_empty_list()); }
break;
case 275:
#line 1217 "dylan.y"
{ yyval = cons (yyvsp[-2], yyvsp[0]); }
break;
case 276:
#line 1219 "dylan.y"
{ yyval = cons (yyvsp[-1], cons (yyvsp[0], make_empty_list())); }
break;
case 277:
#line 1223 "dylan.y"
{ yyval = (yyvsp[0] ? cons (yyvsp[-1], cons (yyvsp[0], make_empty_list()))
			: yyvsp[-1]); }
break;
case 278:
#line 1227 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 279:
#line 1228 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 280:
#line 1231 "dylan.y"
{ yyval = NULL; }
break;
case 281:
#line 1232 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 282:
#line 1235 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 283:
#line 1237 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 284:
#line 1243 "dylan.y"
{ yyval = cons (yyvsp[0], make_empty_list()); }
break;
case 285:
#line 1244 "dylan.y"
{ yyval = cons (yyvsp[-1], yyvsp[0]); }
break;
case 286:
#line 1248 "dylan.y"
{ yyval = cons (yyvsp[-1], yyvsp[0]); }
break;
case 287:
#line 1250 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 288:
#line 1251 "dylan.y"
{ yyval = yyvsp[-1]; }
break;
case 289:
#line 1254 "dylan.y"
{ yyval = cons (yyvsp[0], make_empty_list()); }
break;
case 290:
#line 1255 "dylan.y"
{ yyval = cons (yyvsp[-2], yyvsp[0]); }
break;
case 291:
#line 1258 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 292:
#line 1260 "dylan.y"
{ yyval = cons (yyvsp[-2], yyvsp[0]); }
break;
case 293:
#line 1263 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 294:
#line 1269 "dylan.y"
{ yyval = NULL; }
break;
case 295:
#line 1270 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 310:
#line 1301 "dylan.y"
{ yyval = make_empty_list(); }
break;
case 311:
#line 1302 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 312:
#line 1305 "dylan.y"
{ yyval = make_empty_list(); }
break;
case 313:
#line 1306 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 314:
#line 1309 "dylan.y"
{ yyval = make_empty_list(); }
break;
case 315:
#line 1310 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 316:
#line 1313 "dylan.y"
{ yyval = cons (list_symbol,
						     make_empty_list()); }
break;
case 317:
#line 1315 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 318:
#line 1318 "dylan.y"
{ yyval = NULL; }
break;
case 319:
#line 1319 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 320:
#line 1332 "dylan.y"
{ yyval = make_empty_list(); }
break;
case 321:
#line 1333 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 322:
#line 1342 "dylan.y"
{ yyval = make_empty_list(); }
break;
case 323:
#line 1343 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 324:
#line 1346 "dylan.y"
{ yyval = make_empty_list(); }
break;
case 325:
#line 1347 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 326:
#line 1350 "dylan.y"
{ yyval = make_empty_list(); }
break;
case 327:
#line 1351 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 328:
#line 1354 "dylan.y"
{ yyval = make_empty_list(); }
break;
case 329:
#line 1355 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 330:
#line 1358 "dylan.y"
{ yyval = NULL; }
break;
case 331:
#line 1359 "dylan.y"
{ yyval = yyvsp[0]; }
break;
case 332:
#line 1362 "dylan.y"
{ yyval = make_empty_list(); }
break;
case 333:
#line 1363 "dylan.y"
{ yyval = yyvsp[0]; }
break;
#line 3684 "y.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yyss + yystacksize - 1)
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
